c Define statement functions for difference approximations of order 8 
c Thsi file was generated by op/src/makeIncludeNew.p  
c Arguments: u,rx,dr,dx: names for the grid function, jacobian, unit square spacing and rectangular grid spacing
c To include derivatives of rx use OPTION=RX
#beginMacro defineDifferenceNewOrder8Components0(u,rx,dr,dx,OPTION)

#If #OPTION == "RX"
dr ## 18(kd) = 1./(840.*dr(kd))
dr ## 28(kd) = 1./(5040.*dr(kd)**2)
#End

u ## r8(i1,i2,i3)=(672.*(u(i1+1,i2,i3)-u(i1-1,i2,i3))-168.*(u(i1+2,i2,i3)-u(i1-2,i2,i3))+32.*(u(i1+3,i2,i3)-u(i1-3,i2,i3))-3.*(u(i1+4,i2,i3)-u(i1-4,i2,i3)))*dr ## 18(0)
u ## s8(i1,i2,i3)=(672.*(u(i1,i2+1,i3)-u(i1,i2-1,i3))-168.*(u(i1,i2+2,i3)-u(i1,i2-2,i3))+32.*(u(i1,i2+3,i3)-u(i1,i2-3,i3))-3.*(u(i1,i2+4,i3)-u(i1,i2-4,i3)))*dr ## 18(1)
u ## t8(i1,i2,i3)=(672.*(u(i1,i2,i3+1)-u(i1,i2,i3-1))-168.*(u(i1,i2,i3+2)-u(i1,i2,i3-2))+32.*(u(i1,i2,i3+3)-u(i1,i2,i3-3))-3.*(u(i1,i2,i3+4)-u(i1,i2,i3-4)))*dr ## 18(2)

u ## rr8(i1,i2,i3)=(-14350.*u(i1,i2,i3)+8064.*(u(i1+1,i2,i3)+u(i1-1,i2,i3))-1008.*(u(i1+2,i2,i3)+u(i1-2,i2,i3))+128.*(u(i1+3,i2,i3)+u(i1-3,i2,i3))-9.*(u(i1+4,i2,i3)+u(i1-4,i2,i3)) )*dr ## 28(0)
u ## ss8(i1,i2,i3)=(-14350.*u(i1,i2,i3)+8064.*(u(i1,i2+1,i3)+u(i1,i2-1,i3))-1008.*(u(i1,i2+2,i3)+u(i1,i2-2,i3))+128.*(u(i1,i2+3,i3)+u(i1,i2-3,i3))-9.*(u(i1,i2+4,i3)+u(i1,i2-4,i3)) )*dr ## 28(1)
u ## tt8(i1,i2,i3)=(-14350.*u(i1,i2,i3)+8064.*(u(i1,i2,i3+1)+u(i1,i2,i3-1))-1008.*(u(i1,i2,i3+2)+u(i1,i2,i3-2))+128.*(u(i1,i2,i3+3)+u(i1,i2,i3-3))-9.*(u(i1,i2,i3+4)+u(i1,i2,i3-4)) )*dr ## 28(2)
u ## rs8(i1,i2,i3)=(672.*(u ## r8(i1,i2+1,i3)-u ## r8(i1,i2-1,i3))-168.*(u ## r8(i1,i2+2,i3)-u ## r8(i1,i2-2,i3))+32.*(u ## r8(i1,i2+3,i3)-u ## r8(i1,i2-3,i3))-3.*(u ## r8(i1,i2+4,i3)-u ## r8(i1,i2-4,i3)))*dr ## 18(1)
u ## rt8(i1,i2,i3)=(672.*(u ## r8(i1,i2,i3+1)-u ## r8(i1,i2,i3-1))-168.*(u ## r8(i1,i2,i3+2)-u ## r8(i1,i2,i3-2))+32.*(u ## r8(i1,i2,i3+3)-u ## r8(i1,i2,i3-3))-3.*(u ## r8(i1,i2,i3+4)-u ## r8(i1,i2,i3-4)))*dr ## 18(2)
u ## st8(i1,i2,i3)=(672.*(u ## s8(i1,i2,i3+1)-u ## s8(i1,i2,i3-1))-168.*(u ## s8(i1,i2,i3+2)-u ## s8(i1,i2,i3-2))+32.*(u ## s8(i1,i2,i3+3)-u ## s8(i1,i2,i3-3))-3.*(u ## s8(i1,i2,i3+4)-u ## s8(i1,i2,i3-4)))*dr ## 18(2)

#If #OPTION == "RX"
rx ##r8(i1,i2,i3,m,n)=(672.*(rx ##(i1+1,i2,i3,m,n)-rx ##(i1-1,i2,i3,m,n))-168.*(rx ##(i1+2,i2,i3,m,n)-rx ##(i1-2,i2,i3,m,n))+32.*(rx ##(i1+3,i2,i3,m,n)-rx ##(i1-3,i2,i3,m,n))-3.*(rx ##(i1+4,i2,i3,m,n)-rx ##(i1-4,i2,i3,m,n)))*dr ## 18(0)
rx ##s8(i1,i2,i3,m,n)=(672.*(rx ##(i1,i2+1,i3,m,n)-rx ##(i1,i2-1,i3,m,n))-168.*(rx ##(i1,i2+2,i3,m,n)-rx ##(i1,i2-2,i3,m,n))+32.*(rx ##(i1,i2+3,i3,m,n)-rx ##(i1,i2-3,i3,m,n))-3.*(rx ##(i1,i2+4,i3,m,n)-rx ##(i1,i2-4,i3,m,n)))*dr ## 18(1)
rx ##t8(i1,i2,i3,m,n)=(672.*(rx ##(i1,i2,i3+1,m,n)-rx ##(i1,i2,i3-1,m,n))-168.*(rx ##(i1,i2,i3+2,m,n)-rx ##(i1,i2,i3-2,m,n))+32.*(rx ##(i1,i2,i3+3,m,n)-rx ##(i1,i2,i3-3,m,n))-3.*(rx ##(i1,i2,i3+4,m,n)-rx ##(i1,i2,i3-4,m,n)))*dr ## 18(2)
#End

u ## x81(i1,i2,i3)= rx(i1,i2,i3,0,0)*u ## r8(i1,i2,i3)
u ## y81(i1,i2,i3)=0
u ## z81(i1,i2,i3)=0

u ## x82(i1,i2,i3)= rx(i1,i2,i3,0,0)*u ## r8(i1,i2,i3)+rx(i1,i2,i3,1,0)*u ## s8(i1,i2,i3)
u ## y82(i1,i2,i3)= rx(i1,i2,i3,0,1)*u ## r8(i1,i2,i3)+rx(i1,i2,i3,1,1)*u ## s8(i1,i2,i3)
u ## z82(i1,i2,i3)=0
u ## x83(i1,i2,i3)=rx(i1,i2,i3,0,0)*u ## r8(i1,i2,i3)+rx(i1,i2,i3,1,0)*u ## s8(i1,i2,i3)+rx(i1,i2,i3,2,0)*u ## t8(i1,i2,i3)
u ## y83(i1,i2,i3)=rx(i1,i2,i3,0,1)*u ## r8(i1,i2,i3)+rx(i1,i2,i3,1,1)*u ## s8(i1,i2,i3)+rx(i1,i2,i3,2,1)*u ## t8(i1,i2,i3)
u ## z83(i1,i2,i3)=rx(i1,i2,i3,0,2)*u ## r8(i1,i2,i3)+rx(i1,i2,i3,1,2)*u ## s8(i1,i2,i3)+rx(i1,i2,i3,2,2)*u ## t8(i1,i2,i3)

#If #OPTION == "RX"
rx ## x81(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r8(i1,i2,i3,m,n)
rx ##x82(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s8(i1,i2,i3,m,n)
rx ##y82(i1,i2,i3,m,n)= rx(i1,i2,i3,0,1)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s8(i1,i2,i3,m,n)
rx ##x83(i1,i2,i3,m,n)=rx(i1,i2,i3,0,0)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s8(i1,i2,i3,m,n)+rx(i1,i2,i3,2,0)*rx ##t8(i1,i2,i3,m,n)
rx ##y83(i1,i2,i3,m,n)=rx(i1,i2,i3,0,1)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s8(i1,i2,i3,m,n)+rx(i1,i2,i3,2,1)*rx ##t8(i1,i2,i3,m,n)
rx ##z83(i1,i2,i3,m,n)=rx(i1,i2,i3,0,2)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,2)*rx ##s8(i1,i2,i3,m,n)+rx(i1,i2,i3,2,2)*rx ##t8(i1,i2,i3,m,n)
#End

u ## xx81(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2)*u ## rr8(i1,i2,i3)+(rx ## x8 ## 2(i1,i2,i3,0,0))*u ## r8(i1,i2,i3)
u ## yy81(i1,i2,i3)=0
u ## xy81(i1,i2,i3)=0
u ## xz81(i1,i2,i3)=0
u ## yz81(i1,i2,i3)=0
u ## zz81(i1,i2,i3)=0
u ## laplacian81(i1,i2,i3)=u ## xx81(i1,i2,i3)
u ## xx82(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2)*u ## rr8(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3)+(rx(i1,i2,i3,1,0)**2)*u ## ss8(i1,i2,i3)+(rx ## x8 ## 2(i1,i2,i3,0,0))*u ## r8(i1,i2,i3)+(rx ## x8 ## 2(i1,i2,i3,1,0))*u ## s8(i1,i2,i3)
u ## yy82(i1,i2,i3)=(rx(i1,i2,i3,0,1)**2)*u ## rr8(i1,i2,i3)+2.*(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs8(i1,i2,i3)+(rx(i1,i2,i3,1,1)**2)*u ## ss8(i1,i2,i3)+(rx ## y8 ## 2(i1,i2,i3,0,1))*u ## r8(i1,i2,i3)+(rx ## y8 ## 2(i1,i2,i3,1,1))*u ## s8(i1,i2,i3)
u ## xy82(i1,i2,i3)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr8(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss8(i1,i2,i3)+rx ## x8 ## 2(i1,i2,i3,0,1)*u ## r8(i1,i2,i3)+rx ## x8 ## 2(i1,i2,i3,1,1)*u ## s8(i1,i2,i3)
u ## xz82(i1,i2,i3)=0
u ## yz82(i1,i2,i3)=0
u ## zz82(i1,i2,i3)=0
u ## laplacian82(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2)*u ## rr8(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs8(i1,i2,i3)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2)*u ## ss8(i1,i2,i3)+(rx ## x8 ## 2(i1,i2,i3,0,0)+rx ## y8 ## 2(i1,i2,i3,0,1))*u ## r8(i1,i2,i3)+(rx ## x8 ## 2(i1,i2,i3,1,0)+rx ## y8 ## 2(i1,i2,i3,1,1))*u ## s8(i1,i2,i3)
u ## xx83(i1,i2,i3)=rx(i1,i2,i3,0,0)**2*u ## rr8(i1,i2,i3)+rx(i1,i2,i3,1,0)**2*u ## ss8(i1,i2,i3)+rx(i1,i2,i3,2,0)**2*u ## tt8(i1,i2,i3)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)*u ## rs8(i1,i2,i3)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)*u ## rt8(i1,i2,i3)+2.*rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)*u ## st8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,0,0)*u ## r8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,1,0)*u ## s8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,2,0)*u ## t8(i1,i2,i3)
u ## yy83(i1,i2,i3)=rx(i1,i2,i3,0,1)**2*u ## rr8(i1,i2,i3)+rx(i1,i2,i3,1,1)**2*u ## ss8(i1,i2,i3)+rx(i1,i2,i3,2,1)**2*u ## tt8(i1,i2,i3)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)*u ## rs8(i1,i2,i3)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)*u ## rt8(i1,i2,i3)+2.*rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)*u ## st8(i1,i2,i3)+rx ## y8 ## 3(i1,i2,i3,0,1)*u ## r8(i1,i2,i3)+rx ## y8 ## 3(i1,i2,i3,1,1)*u ## s8(i1,i2,i3)+rx ## y8 ## 3(i1,i2,i3,2,1)*u ## t8(i1,i2,i3)
u ## zz83(i1,i2,i3)=rx(i1,i2,i3,0,2)**2*u ## rr8(i1,i2,i3)+rx(i1,i2,i3,1,2)**2*u ## ss8(i1,i2,i3)+rx(i1,i2,i3,2,2)**2*u ## tt8(i1,i2,i3)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2)*u ## rs8(i1,i2,i3)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2)*u ## rt8(i1,i2,i3)+2.*rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2)*u ## st8(i1,i2,i3)+rx ## z8 ## 3(i1,i2,i3,0,2)*u ## r8(i1,i2,i3)+rx ## z8 ## 3(i1,i2,i3,1,2)*u ## s8(i1,i2,i3)+rx ## z8 ## 3(i1,i2,i3,2,2)*u ## t8(i1,i2,i3)
u ## xy83(i1,i2,i3)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr8(i1,i2,i3)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss8(i1,i2,i3)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,1)*u ## tt8(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,0))*u ## rt8(i1,i2,i3)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,0))*u ## st8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,0,1)*u ## r8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,1,1)*u ## s8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,2,1)*u ## t8(i1,i2,i3)
u ## xz83(i1,i2,i3)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,2)*u ## rr8(i1,i2,i3)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,2)*u ## ss8(i1,i2,i3)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,2)*u ## tt8(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,0))*u ## rt8(i1,i2,i3)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,0))*u ## st8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,0,2)*u ## r8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,1,2)*u ## s8(i1,i2,i3)+rx ## x8 ## 3(i1,i2,i3,2,2)*u ## t8(i1,i2,i3)
u ## yz83(i1,i2,i3)=rx(i1,i2,i3,0,1)*rx(i1,i2,i3,0,2)*u ## rr8(i1,i2,i3)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,1,2)*u ## ss8(i1,i2,i3)+rx(i1,i2,i3,2,1)*rx(i1,i2,i3,2,2)*u ## tt8(i1,i2,i3)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,1))*u ## rs8(i1,i2,i3)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,1))*u ## rt8(i1,i2,i3)+(rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,1))*u ## st8(i1,i2,i3)+rx ## y8 ## 3(i1,i2,i3,0,2)*u ## r8(i1,i2,i3)+rx ## y8 ## 3(i1,i2,i3,1,2)*u ## s8(i1,i2,i3)+rx ## y8 ## 3(i1,i2,i3,2,2)*u ## t8(i1,i2,i3)
u ## laplacian83(i1,i2,i3)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2+rx(i1,i2,i3,0,2)**2)*u ## rr8(i1,i2,i3)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2+rx(i1,i2,i3,1,2)**2)*u ## ss8(i1,i2,i3)+(rx(i1,i2,i3,2,0)**2+rx(i1,i2,i3,2,1)**2+rx(i1,i2,i3,2,2)**2)*u ## tt8(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2))*u ## rs8(i1,i2,i3)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2))*u ## rt8(i1,i2,i3)+2.*(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2))*u ## st8(i1,i2,i3)+(rx ## x8 ## 3(i1,i2,i3,0,0)+rx ## y8 ## 3(i1,i2,i3,0,1)+rx ## z8 ## 3(i1,i2,i3,0,2))*u ## r8(i1,i2,i3)+(rx ## x8 ## 3(i1,i2,i3,1,0)+rx ## y8 ## 3(i1,i2,i3,1,1)+rx ## z8 ## 3(i1,i2,i3,1,2))*u ## s8(i1,i2,i3)+(rx ## x8 ## 3(i1,i2,i3,2,0)+rx ## y8 ## 3(i1,i2,i3,2,1)+rx ## z8 ## 3(i1,i2,i3,2,2))*u ## t8(i1,i2,i3)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
#If #OPTION == "RX"
dx ## 18(kd) = 1./(840.*dx(kd))
dx ## 28(kd) = 1./(5040.*dx(kd)**2)
#End

u ## x83r(i1,i2,i3)=(672.*(u(i1+1,i2,i3)-u(i1-1,i2,i3))-168.*(u(i1+2,i2,i3)-u(i1-2,i2,i3))+32.*(u(i1+3,i2,i3)-u(i1-3,i2,i3))-3.*(u(i1+4,i2,i3)-u(i1-4,i2,i3)))*dx ## 18(0)
u ## y83r(i1,i2,i3)=(672.*(u(i1,i2+1,i3)-u(i1,i2-1,i3))-168.*(u(i1,i2+2,i3)-u(i1,i2-2,i3))+32.*(u(i1,i2+3,i3)-u(i1,i2-3,i3))-3.*(u(i1,i2+4,i3)-u(i1,i2-4,i3)))*dx ## 18(1)
u ## z83r(i1,i2,i3)=(672.*(u(i1,i2,i3+1)-u(i1,i2,i3-1))-168.*(u(i1,i2,i3+2)-u(i1,i2,i3-2))+32.*(u(i1,i2,i3+3)-u(i1,i2,i3-3))-3.*(u(i1,i2,i3+4)-u(i1,i2,i3-4)))*dx ## 18(2)

u ## xx83r(i1,i2,i3)=(-14350.*u(i1,i2,i3)+8064.*(u(i1+1,i2,i3)+u(i1-1,i2,i3))-1008.*(u(i1+2,i2,i3)+u(i1-2,i2,i3))+128.*(u(i1+3,i2,i3)+u(i1-3,i2,i3))-9.*(u(i1+4,i2,i3)+u(i1-4,i2,i3)) )*dx ## 28(0)
u ## yy83r(i1,i2,i3)=(-14350.*u(i1,i2,i3)+8064.*(u(i1,i2+1,i3)+u(i1,i2-1,i3))-1008.*(u(i1,i2+2,i3)+u(i1,i2-2,i3))+128.*(u(i1,i2+3,i3)+u(i1,i2-3,i3))-9.*(u(i1,i2+4,i3)+u(i1,i2-4,i3)) )*dx ## 28(1)
u ## zz83r(i1,i2,i3)=(-14350.*u(i1,i2,i3)+8064.*(u(i1,i2,i3+1)+u(i1,i2,i3-1))-1008.*(u(i1,i2,i3+2)+u(i1,i2,i3-2))+128.*(u(i1,i2,i3+3)+u(i1,i2,i3-3))-9.*(u(i1,i2,i3+4)+u(i1,i2,i3-4)) )*dx ## 28(2)
u ## xy83r(i1,i2,i3)=(672.*(u ## x83r(i1,i2+1,i3)-u ## x83r(i1,i2-1,i3))-168.*(u ## x83r(i1,i2+2,i3)-u ## x83r(i1,i2-2,i3))+32.*(u ## x83r(i1,i2+3,i3)-u ## x83r(i1,i2-3,i3))-3.*(u ## x83r(i1,i2+4,i3)-u ## x83r(i1,i2-4,i3)))*dx ## 18(1)
u ## xz83r(i1,i2,i3)=(672.*(u ## x83r(i1,i2,i3+1)-u ## x83r(i1,i2,i3-1))-168.*(u ## x83r(i1,i2,i3+2)-u ## x83r(i1,i2,i3-2))+32.*(u ## x83r(i1,i2,i3+3)-u ## x83r(i1,i2,i3-3))-3.*(u ## x83r(i1,i2,i3+4)-u ## x83r(i1,i2,i3-4)))*dx ## 18(2)
u ## yz83r(i1,i2,i3)=(672.*(u ## y83r(i1,i2,i3+1)-u ## y83r(i1,i2,i3-1))-168.*(u ## y83r(i1,i2,i3+2)-u ## y83r(i1,i2,i3-2))+32.*(u ## y83r(i1,i2,i3+3)-u ## y83r(i1,i2,i3-3))-3.*(u ## y83r(i1,i2,i3+4)-u ## y83r(i1,i2,i3-4)))*dx ## 18(2)

u ## x81r(i1,i2,i3)= u ## x83r(i1,i2,i3)
u ## y81r(i1,i2,i3)= u ## y83r(i1,i2,i3)
u ## z81r(i1,i2,i3)= u ## z83r(i1,i2,i3)
u ## xx81r(i1,i2,i3)= u ## xx83r(i1,i2,i3)
u ## yy81r(i1,i2,i3)= u ## yy83r(i1,i2,i3)
u ## zz81r(i1,i2,i3)= u ## zz83r(i1,i2,i3)
u ## xy81r(i1,i2,i3)= u ## xy83r(i1,i2,i3)
u ## xz81r(i1,i2,i3)= u ## xz83r(i1,i2,i3)
u ## yz81r(i1,i2,i3)= u ## yz83r(i1,i2,i3)
u ## laplacian81r(i1,i2,i3)=u ## xx83r(i1,i2,i3)
u ## x82r(i1,i2,i3)= u ## x83r(i1,i2,i3)
u ## y82r(i1,i2,i3)= u ## y83r(i1,i2,i3)
u ## z82r(i1,i2,i3)= u ## z83r(i1,i2,i3)
u ## xx82r(i1,i2,i3)= u ## xx83r(i1,i2,i3)
u ## yy82r(i1,i2,i3)= u ## yy83r(i1,i2,i3)
u ## zz82r(i1,i2,i3)= u ## zz83r(i1,i2,i3)
u ## xy82r(i1,i2,i3)= u ## xy83r(i1,i2,i3)
u ## xz82r(i1,i2,i3)= u ## xz83r(i1,i2,i3)
u ## yz82r(i1,i2,i3)= u ## yz83r(i1,i2,i3)
u ## laplacian82r(i1,i2,i3)=u ## xx83r(i1,i2,i3)+u ## yy83r(i1,i2,i3)
u ## laplacian83r(i1,i2,i3)=u ## xx83r(i1,i2,i3)+u ## yy83r(i1,i2,i3)+u ## zz83r(i1,i2,i3)
#endMacro
c Arguments: u,rx,dr,dx: names for the grid function, jacobian, unit square spacing and rectangular grid spacing
c To include derivatives of rx use OPTION=RX
#beginMacro defineDifferenceNewOrder8Components1(u,rx,dr,dx,OPTION)

#If #OPTION == "RX"
dr ## 18(kd) = 1./(840.*dr(kd))
dr ## 28(kd) = 1./(5040.*dr(kd)**2)
#End

u ## r8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*dr ## 18(0)
u ## s8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*dr ## 18(1)
u ## t8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*dr ## 18(2)

u ## rr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+u(i1-4,i2,i3,kd)) )*dr ## 28(0)
u ## ss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+u(i1,i2-4,i3,kd)) )*dr ## 28(1)
u ## tt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+u(i1,i2,i3-4,kd)) )*dr ## 28(2)
u ## rs8(i1,i2,i3,kd)=(672.*(u ## r8(i1,i2+1,i3,kd)-u ## r8(i1,i2-1,i3,kd))-168.*(u ## r8(i1,i2+2,i3,kd)-u ## r8(i1,i2-2,i3,kd))+32.*(u ## r8(i1,i2+3,i3,kd)-u ## r8(i1,i2-3,i3,kd))-3.*(u ## r8(i1,i2+4,i3,kd)-u ## r8(i1,i2-4,i3,kd)))*dr ## 18(1)
u ## rt8(i1,i2,i3,kd)=(672.*(u ## r8(i1,i2,i3+1,kd)-u ## r8(i1,i2,i3-1,kd))-168.*(u ## r8(i1,i2,i3+2,kd)-u ## r8(i1,i2,i3-2,kd))+32.*(u ## r8(i1,i2,i3+3,kd)-u ## r8(i1,i2,i3-3,kd))-3.*(u ## r8(i1,i2,i3+4,kd)-u ## r8(i1,i2,i3-4,kd)))*dr ## 18(2)
u ## st8(i1,i2,i3,kd)=(672.*(u ## s8(i1,i2,i3+1,kd)-u ## s8(i1,i2,i3-1,kd))-168.*(u ## s8(i1,i2,i3+2,kd)-u ## s8(i1,i2,i3-2,kd))+32.*(u ## s8(i1,i2,i3+3,kd)-u ## s8(i1,i2,i3-3,kd))-3.*(u ## s8(i1,i2,i3+4,kd)-u ## s8(i1,i2,i3-4,kd)))*dr ## 18(2)

#If #OPTION == "RX"
rx ##r8(i1,i2,i3,m,n)=(672.*(rx ##(i1+1,i2,i3,m,n)-rx ##(i1-1,i2,i3,m,n))-168.*(rx ##(i1+2,i2,i3,m,n)-rx ##(i1-2,i2,i3,m,n))+32.*(rx ##(i1+3,i2,i3,m,n)-rx ##(i1-3,i2,i3,m,n))-3.*(rx ##(i1+4,i2,i3,m,n)-rx ##(i1-4,i2,i3,m,n)))*dr ## 18(0)
rx ##s8(i1,i2,i3,m,n)=(672.*(rx ##(i1,i2+1,i3,m,n)-rx ##(i1,i2-1,i3,m,n))-168.*(rx ##(i1,i2+2,i3,m,n)-rx ##(i1,i2-2,i3,m,n))+32.*(rx ##(i1,i2+3,i3,m,n)-rx ##(i1,i2-3,i3,m,n))-3.*(rx ##(i1,i2+4,i3,m,n)-rx ##(i1,i2-4,i3,m,n)))*dr ## 18(1)
rx ##t8(i1,i2,i3,m,n)=(672.*(rx ##(i1,i2,i3+1,m,n)-rx ##(i1,i2,i3-1,m,n))-168.*(rx ##(i1,i2,i3+2,m,n)-rx ##(i1,i2,i3-2,m,n))+32.*(rx ##(i1,i2,i3+3,m,n)-rx ##(i1,i2,i3-3,m,n))-3.*(rx ##(i1,i2,i3+4,m,n)-rx ##(i1,i2,i3-4,m,n)))*dr ## 18(2)
#End

u ## x81(i1,i2,i3,kd)= rx(i1,i2,i3,0,0)*u ## r8(i1,i2,i3,kd)
u ## y81(i1,i2,i3,kd)=0
u ## z81(i1,i2,i3,kd)=0

u ## x82(i1,i2,i3,kd)= rx(i1,i2,i3,0,0)*u ## r8(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*u ## s8(i1,i2,i3,kd)
u ## y82(i1,i2,i3,kd)= rx(i1,i2,i3,0,1)*u ## r8(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)*u ## s8(i1,i2,i3,kd)
u ## z82(i1,i2,i3,kd)=0
u ## x83(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*u ## r8(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*u ## s8(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)*u ## t8(i1,i2,i3,kd)
u ## y83(i1,i2,i3,kd)=rx(i1,i2,i3,0,1)*u ## r8(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)*u ## s8(i1,i2,i3,kd)+rx(i1,i2,i3,2,1)*u ## t8(i1,i2,i3,kd)
u ## z83(i1,i2,i3,kd)=rx(i1,i2,i3,0,2)*u ## r8(i1,i2,i3,kd)+rx(i1,i2,i3,1,2)*u ## s8(i1,i2,i3,kd)+rx(i1,i2,i3,2,2)*u ## t8(i1,i2,i3,kd)

#If #OPTION == "RX"
rx ## x81(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r8(i1,i2,i3,m,n)
rx ##x82(i1,i2,i3,m,n)= rx(i1,i2,i3,0,0)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s8(i1,i2,i3,m,n)
rx ##y82(i1,i2,i3,m,n)= rx(i1,i2,i3,0,1)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s8(i1,i2,i3,m,n)
rx ##x83(i1,i2,i3,m,n)=rx(i1,i2,i3,0,0)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,0)*rx ##s8(i1,i2,i3,m,n)+rx(i1,i2,i3,2,0)*rx ##t8(i1,i2,i3,m,n)
rx ##y83(i1,i2,i3,m,n)=rx(i1,i2,i3,0,1)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,1)*rx ##s8(i1,i2,i3,m,n)+rx(i1,i2,i3,2,1)*rx ##t8(i1,i2,i3,m,n)
rx ##z83(i1,i2,i3,m,n)=rx(i1,i2,i3,0,2)*rx ##r8(i1,i2,i3,m,n)+rx(i1,i2,i3,1,2)*rx ##s8(i1,i2,i3,m,n)+rx(i1,i2,i3,2,2)*rx ##t8(i1,i2,i3,m,n)
#End

u ## xx81(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2)*u ## rr8(i1,i2,i3,kd)+(rx ## x8 ## 2(i1,i2,i3,0,0))*u ## r8(i1,i2,i3,kd)
u ## yy81(i1,i2,i3,kd)=0
u ## xy81(i1,i2,i3,kd)=0
u ## xz81(i1,i2,i3,kd)=0
u ## yz81(i1,i2,i3,kd)=0
u ## zz81(i1,i2,i3,kd)=0
u ## laplacian81(i1,i2,i3,kd)=u ## xx81(i1,i2,i3,kd)
u ## xx82(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2)*u ## rr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)**2)*u ## ss8(i1,i2,i3,kd)+(rx ## x8 ## 2(i1,i2,i3,0,0))*u ## r8(i1,i2,i3,kd)+(rx ## x8 ## 2(i1,i2,i3,1,0))*u ## s8(i1,i2,i3,kd)
u ## yy82(i1,i2,i3,kd)=(rx(i1,i2,i3,0,1)**2)*u ## rr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,1)**2)*u ## ss8(i1,i2,i3,kd)+(rx ## y8 ## 2(i1,i2,i3,0,1))*u ## r8(i1,i2,i3,kd)+(rx ## y8 ## 2(i1,i2,i3,1,1))*u ## s8(i1,i2,i3,kd)
u ## xy82(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss8(i1,i2,i3,kd)+rx ## x8 ## 2(i1,i2,i3,0,1)*u ## r8(i1,i2,i3,kd)+rx ## x8 ## 2(i1,i2,i3,1,1)*u ## s8(i1,i2,i3,kd)
u ## xz82(i1,i2,i3,kd)=0
u ## yz82(i1,i2,i3,kd)=0
u ## zz82(i1,i2,i3,kd)=0
u ## laplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2)*u ## rr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1))*u ## rs8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2)*u ## ss8(i1,i2,i3,kd)+(rx ## x8 ## 2(i1,i2,i3,0,0)+rx ## y8 ## 2(i1,i2,i3,0,1))*u ## r8(i1,i2,i3,kd)+(rx ## x8 ## 2(i1,i2,i3,1,0)+rx ## y8 ## 2(i1,i2,i3,1,1))*u ## s8(i1,i2,i3,kd)
u ## xx83(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)**2*u ## rr8(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)**2*u ## ss8(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)**2*u ## tt8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)*u ## rs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)*u ## rt8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)*u ## st8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,0,0)*u ## r8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,1,0)*u ## s8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,2,0)*u ## t8(i1,i2,i3,kd)
u ## yy83(i1,i2,i3,kd)=rx(i1,i2,i3,0,1)**2*u ## rr8(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)**2*u ## ss8(i1,i2,i3,kd)+rx(i1,i2,i3,2,1)**2*u ## tt8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)*u ## rs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)*u ## rt8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)*u ## st8(i1,i2,i3,kd)+rx ## y8 ## 3(i1,i2,i3,0,1)*u ## r8(i1,i2,i3,kd)+rx ## y8 ## 3(i1,i2,i3,1,1)*u ## s8(i1,i2,i3,kd)+rx ## y8 ## 3(i1,i2,i3,2,1)*u ## t8(i1,i2,i3,kd)
u ## zz83(i1,i2,i3,kd)=rx(i1,i2,i3,0,2)**2*u ## rr8(i1,i2,i3,kd)+rx(i1,i2,i3,1,2)**2*u ## ss8(i1,i2,i3,kd)+rx(i1,i2,i3,2,2)**2*u ## tt8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2)*u ## rs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2)*u ## rt8(i1,i2,i3,kd)+2.*rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2)*u ## st8(i1,i2,i3,kd)+rx ## z8 ## 3(i1,i2,i3,0,2)*u ## r8(i1,i2,i3,kd)+rx ## z8 ## 3(i1,i2,i3,1,2)*u ## s8(i1,i2,i3,kd)+rx ## z8 ## 3(i1,i2,i3,2,2)*u ## t8(i1,i2,i3,kd)
u ## xy83(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,1)*u ## rr8(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,1)*u ## ss8(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,1)*u ## tt8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,0))*u ## rt8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,0))*u ## st8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,0,1)*u ## r8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,1,1)*u ## s8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,2,1)*u ## t8(i1,i2,i3,kd)
u ## xz83(i1,i2,i3,kd)=rx(i1,i2,i3,0,0)*rx(i1,i2,i3,0,2)*u ## rr8(i1,i2,i3,kd)+rx(i1,i2,i3,1,0)*rx(i1,i2,i3,1,2)*u ## ss8(i1,i2,i3,kd)+rx(i1,i2,i3,2,0)*rx(i1,i2,i3,2,2)*u ## tt8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,0))*u ## rs8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,0))*u ## rt8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,0))*u ## st8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,0,2)*u ## r8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,1,2)*u ## s8(i1,i2,i3,kd)+rx ## x8 ## 3(i1,i2,i3,2,2)*u ## t8(i1,i2,i3,kd)
u ## yz83(i1,i2,i3,kd)=rx(i1,i2,i3,0,1)*rx(i1,i2,i3,0,2)*u ## rr8(i1,i2,i3,kd)+rx(i1,i2,i3,1,1)*rx(i1,i2,i3,1,2)*u ## ss8(i1,i2,i3,kd)+rx(i1,i2,i3,2,1)*rx(i1,i2,i3,2,2)*u ## tt8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,1))*u ## rs8(i1,i2,i3,kd)+(rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,1))*u ## rt8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,2)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,1))*u ## st8(i1,i2,i3,kd)+rx ## y8 ## 3(i1,i2,i3,0,2)*u ## r8(i1,i2,i3,kd)+rx ## y8 ## 3(i1,i2,i3,1,2)*u ## s8(i1,i2,i3,kd)+rx ## y8 ## 3(i1,i2,i3,2,2)*u ## t8(i1,i2,i3,kd)
u ## laplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3,0,0)**2+rx(i1,i2,i3,0,1)**2+rx(i1,i2,i3,0,2)**2)*u ## rr8(i1,i2,i3,kd)+(rx(i1,i2,i3,1,0)**2+rx(i1,i2,i3,1,1)**2+rx(i1,i2,i3,1,2)**2)*u ## ss8(i1,i2,i3,kd)+(rx(i1,i2,i3,2,0)**2+rx(i1,i2,i3,2,1)**2+rx(i1,i2,i3,2,2)**2)*u ## tt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,1,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,1,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,1,2))*u ## rs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,0,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,0,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,0,2)*rx(i1,i2,i3,2,2))*u ## rt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3,1,0)*rx(i1,i2,i3,2,0)+ rx(i1,i2,i3,1,1)*rx(i1,i2,i3,2,1)+rx(i1,i2,i3,1,2)*rx(i1,i2,i3,2,2))*u ## st8(i1,i2,i3,kd)+(rx ## x8 ## 3(i1,i2,i3,0,0)+rx ## y8 ## 3(i1,i2,i3,0,1)+rx ## z8 ## 3(i1,i2,i3,0,2))*u ## r8(i1,i2,i3,kd)+(rx ## x8 ## 3(i1,i2,i3,1,0)+rx ## y8 ## 3(i1,i2,i3,1,1)+rx ## z8 ## 3(i1,i2,i3,1,2))*u ## s8(i1,i2,i3,kd)+(rx ## x8 ## 3(i1,i2,i3,2,0)+rx ## y8 ## 3(i1,i2,i3,2,1)+rx ## z8 ## 3(i1,i2,i3,2,2))*u ## t8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
#If #OPTION == "RX"
dx ## 18(kd) = 1./(840.*dx(kd))
dx ## 28(kd) = 1./(5040.*dx(kd)**2)
#End

u ## x83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*dx ## 18(0)
u ## y83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*dx ## 18(1)
u ## z83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*dx ## 18(2)

u ## xx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+u(i1-4,i2,i3,kd)) )*dx ## 28(0)
u ## yy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+u(i1,i2-4,i3,kd)) )*dx ## 28(1)
u ## zz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+u(i1,i2,i3-4,kd)) )*dx ## 28(2)
u ## xy83r(i1,i2,i3,kd)=(672.*(u ## x83r(i1,i2+1,i3,kd)-u ## x83r(i1,i2-1,i3,kd))-168.*(u ## x83r(i1,i2+2,i3,kd)-u ## x83r(i1,i2-2,i3,kd))+32.*(u ## x83r(i1,i2+3,i3,kd)-u ## x83r(i1,i2-3,i3,kd))-3.*(u ## x83r(i1,i2+4,i3,kd)-u ## x83r(i1,i2-4,i3,kd)))*dx ## 18(1)
u ## xz83r(i1,i2,i3,kd)=(672.*(u ## x83r(i1,i2,i3+1,kd)-u ## x83r(i1,i2,i3-1,kd))-168.*(u ## x83r(i1,i2,i3+2,kd)-u ## x83r(i1,i2,i3-2,kd))+32.*(u ## x83r(i1,i2,i3+3,kd)-u ## x83r(i1,i2,i3-3,kd))-3.*(u ## x83r(i1,i2,i3+4,kd)-u ## x83r(i1,i2,i3-4,kd)))*dx ## 18(2)
u ## yz83r(i1,i2,i3,kd)=(672.*(u ## y83r(i1,i2,i3+1,kd)-u ## y83r(i1,i2,i3-1,kd))-168.*(u ## y83r(i1,i2,i3+2,kd)-u ## y83r(i1,i2,i3-2,kd))+32.*(u ## y83r(i1,i2,i3+3,kd)-u ## y83r(i1,i2,i3-3,kd))-3.*(u ## y83r(i1,i2,i3+4,kd)-u ## y83r(i1,i2,i3-4,kd)))*dx ## 18(2)

u ## x81r(i1,i2,i3,kd)= u ## x83r(i1,i2,i3,kd)
u ## y81r(i1,i2,i3,kd)= u ## y83r(i1,i2,i3,kd)
u ## z81r(i1,i2,i3,kd)= u ## z83r(i1,i2,i3,kd)
u ## xx81r(i1,i2,i3,kd)= u ## xx83r(i1,i2,i3,kd)
u ## yy81r(i1,i2,i3,kd)= u ## yy83r(i1,i2,i3,kd)
u ## zz81r(i1,i2,i3,kd)= u ## zz83r(i1,i2,i3,kd)
u ## xy81r(i1,i2,i3,kd)= u ## xy83r(i1,i2,i3,kd)
u ## xz81r(i1,i2,i3,kd)= u ## xz83r(i1,i2,i3,kd)
u ## yz81r(i1,i2,i3,kd)= u ## yz83r(i1,i2,i3,kd)
u ## laplacian81r(i1,i2,i3,kd)=u ## xx83r(i1,i2,i3,kd)
u ## x82r(i1,i2,i3,kd)= u ## x83r(i1,i2,i3,kd)
u ## y82r(i1,i2,i3,kd)= u ## y83r(i1,i2,i3,kd)
u ## z82r(i1,i2,i3,kd)= u ## z83r(i1,i2,i3,kd)
u ## xx82r(i1,i2,i3,kd)= u ## xx83r(i1,i2,i3,kd)
u ## yy82r(i1,i2,i3,kd)= u ## yy83r(i1,i2,i3,kd)
u ## zz82r(i1,i2,i3,kd)= u ## zz83r(i1,i2,i3,kd)
u ## xy82r(i1,i2,i3,kd)= u ## xy83r(i1,i2,i3,kd)
u ## xz82r(i1,i2,i3,kd)= u ## xz83r(i1,i2,i3,kd)
u ## yz82r(i1,i2,i3,kd)= u ## yz83r(i1,i2,i3,kd)
u ## laplacian82r(i1,i2,i3,kd)=u ## xx83r(i1,i2,i3,kd)+u ## yy83r(i1,i2,i3,kd)
u ## laplacian83r(i1,i2,i3,kd)=u ## xx83r(i1,i2,i3,kd)+u ## yy83r(i1,i2,i3,kd)+u ## zz83r(i1,i2,i3,kd)
#endMacro


#beginMacro declareDifferenceNewOrder8(u,rx,dr,dx,OPTION)
real dr ##18
real dr ##28
real u ##r8
real u ##s8
real u ##t8
real u ##rr8
real u ##ss8
real u ##tt8
real u ##rs8
real u ##rt8
real u ##st8
real rx ##r8
real rx ##s8
real rx ##t8
real u ##x81
real u ##y81
real u ##z81
real u ##x82
real u ##y82
real u ##z82
real u ##x83
real u ##y83
real u ##z83
real rx ##x81
real rx ##x82
real rx ##y82
real rx ##x83
real rx ##y83
real rx ##z83
real u ##xx81
real u ##yy81
real u ##xy81
real u ##xz81
real u ##yz81
real u ##zz81
real u ##laplacian81
real u ##xx82
real u ##yy82
real u ##xy82
real u ##xz82
real u ##yz82
real u ##zz82
real u ##laplacian82
real u ##xx83
real u ##yy83
real u ##zz83
real u ##xy83
real u ##xz83
real u ##yz83
real u ##laplacian83
real dx ##18
real dx ##28
real u ##x83r
real u ##y83r
real u ##z83r
real u ##xx83r
real u ##yy83r
real u ##zz83r
real u ##xy83r
real u ##xz83r
real u ##yz83r
real u ##x81r
real u ##y81r
real u ##z81r
real u ##xx81r
real u ##yy81r
real u ##zz81r
real u ##xy81r
real u ##xz81r
real u ##yz81r
real u ##laplacian81r
real u ##x82r
real u ##y82r
real u ##z82r
real u ##xx82r
real u ##yy82r
real u ##zz82r
real u ##xy82r
real u ##xz82r
real u ##yz82r
real u ##laplacian82r
real u ##laplacian83r
#endMacro
