! This file automatically generated from standardDerivative.bf with bpp.
c Define the standard finite difference derivatives 


c These next include files will define the macros that will define the difference approximations
c The actual macro is called below
! #Include "../src/defineDiffOrder2f.h"
c Define statement functions for difference approximations of order 2 
c To include derivatives of rx use OPTION=RX
c To include derivatives of rx use OPTION=RX
! #Include "../src/defineDiffOrder4f.h"
c Define statement functions for difference approximations of order 4 
c To include derivatives of rx use OPTION=RX
c To include derivatives of rx use OPTION=RX
! #Include "../src/defineDiffOrder6f.h"
c Define statement functions for difference approximations of order 6 
c To include derivatives of rx use OPTION=RX
c To include derivatives of rx use OPTION=RX
! #Include "../src/defineDiffOrder8f.h"
c Define statement functions for difference approximations of order 8 
c To include derivatives of rx use OPTION=RX
c To include derivatives of rx use OPTION=RX





c Note: no loop for c



c -- define the gradient --

c -- define the divergence --

c -- define the vorticity --




! finiteDifferenceDerivative(x)
      subroutine xFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "x" == "grad"
!       #Elif "x" == div
!       #Elif "x" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(x,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(x,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(x,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ux81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ux81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ux81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uxORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(y)
      subroutine yFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "y" == "grad"
!       #Elif "y" == div
!       #Elif "y" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(y,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(y,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(y,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uy81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uy81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uy81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uyORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uyORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uyORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(z)
      subroutine zFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "z" == "grad"
!       #Elif "z" == div
!       #Elif "z" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(z,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(z,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(z,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uz81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uz81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uz81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uzORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uzORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uzORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uzORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uzORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uzORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(xx)
      subroutine xxFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "xx" == "grad"
!       #Elif "xx" == div
!       #Elif "xx" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(xx,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(xx,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(xx,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxx81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxx81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxx81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uxxORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxxORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxxORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxxORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxxORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxxORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(xy)
      subroutine xyFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "xy" == "grad"
!       #Elif "xy" == div
!       #Elif "xy" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(xy,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(xy,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(xy,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxy81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxy81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxy81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uxyORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxyORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxyORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxyORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxyORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxyORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(xz)
      subroutine xzFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "xz" == "grad"
!       #Elif "xz" == div
!       #Elif "xz" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(xz,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(xz,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(xz,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uxz81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uxz81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uxz81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uxzORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxzORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxzORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxzORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uxzORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uxzORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(yy)
      subroutine yyFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "yy" == "grad"
!       #Elif "yy" == div
!       #Elif "yy" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(yy,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(yy,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(yy,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyy81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyy81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyy81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uyyORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyyORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uyyORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyyORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uyyORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyyORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(yz)
      subroutine yzFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "yz" == "grad"
!       #Elif "yz" == div
!       #Elif "yz" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(yz,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(yz,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(yz,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uyz81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uyz81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uyz81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uyzORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyzORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uyzORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyzORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uyzORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uyzORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(zz)
      subroutine zzFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, 
     & ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "zz" == "grad"
!       #Elif "zz" == div
!       #Elif "zz" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(zz,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(zz,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(zz,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=uzz81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=uzz81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=uzz81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uzzORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uzzORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uzzORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uzzORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uzzORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uzzORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(laplacian)
      subroutine laplacianFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b, ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, 
     & ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,
     & deriv, rsxy, mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "laplacian" == "grad"
!       #Elif "laplacian" == div
!       #Elif "laplacian" == vorticity
!       #Else

        if( nd .eq. 2 )then
! gridLoops(laplacian,2)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian22r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian22r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian22(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian22(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian42r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian42r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian42(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian42(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian62r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian62r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian62(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian62(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian82r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian82r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian82(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian82(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.3 )then
! gridLoops(laplacian,3)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian23r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian23r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian23(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian23(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian43r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian43r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian43(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian43(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian63r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian63r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian63(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian63(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian83r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian83r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian83(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian83(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else if( nd.eq.1 )then
! gridLoops(laplacian,1)
          if( order.eq.2 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian21r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian21r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian21(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian21(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.4 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian41r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian41r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian41(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian41(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.6 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian61r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian61r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian61(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian61(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          else if( order.eq.8 )then
           if( gridType .eq. rectangular )then
! loops(deriv(i1,i2,i3,c)=ulaplacian81r(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian81r(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           else
! loops(deriv(i1,i2,i3,c)=ulaplacian81(i1,i2,i3,c))
               do c=ca,cb
               do i3=n3a,n3b
               do i2=n2a,n2b
               do i1=n1a,n1b
                 deriv(i1,i2,i3,c)=ulaplacian81(i1,i2,i3,c)
               end do
               end do
               end do
               end do
           endif
          end if
        else
        end if

c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=ulaplacianORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=ulaplacianORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=ulaplacianORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=ulaplacianORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=ulaplacianORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=ulaplacianORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(grad)
      subroutine gradFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,
     & nd3b, ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,
     & ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv,
     &  rsxy, mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "grad" == "grad"
c --- gradient ----
        if( order.eq.2 )then
! gradLoop(2)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux22r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy22r(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux22r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy22r(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux23r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy23r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz23r(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux23r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy23r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz23r(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux21r(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux21r(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux22(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy22(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux22(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy22(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux23(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy23(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz23(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux23(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy23(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz23(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux21(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux21(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.4 )then
! gradLoop(4)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux42r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy42r(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux42r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy42r(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux43r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy43r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz43r(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux43r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy43r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz43r(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux41r(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux41r(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux42(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy42(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux42(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy42(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux43(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy43(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz43(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux43(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy43(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz43(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux41(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux41(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.6 )then
! gradLoop(6)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux62r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy62r(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux62r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy62r(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux63r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy63r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz63r(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux63r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy63r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz63r(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux61r(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux61r(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux62(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy62(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux62(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy62(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux63(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy63(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz63(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux63(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy63(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz63(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux61(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux61(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.8 )then
! gradLoop(8)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux82r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy82r(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux82r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy82r(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux83r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy83r(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz83r(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux83r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy83r(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz83r(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux81r(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux81r(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3(deriv(i1,i2,i3,c      )=ux82(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy82(i1,i2,i3,c),)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux82(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy82(i1,i2,i3,c)

                 end do
                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3(deriv(i1,i2,i3,c      )=ux83(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc  )=uy83(i1,i2,i3,c),deriv(i1,i2,i3,c+ndc*2)=uz83(i1,i2,i3,c))
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux83(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc)=uy83(i1,i2,i3,c)
                   deriv(i1,i2,i3,c+ndc*2)=uz83(i1,i2,i3,c)
                 end do
                 end do
                 end do
                 end do
             else
! loops3(deriv(i1,i2,i3,c      )=ux81(i1,i2,i3,c),,)
                 do c=ca,cb
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,c)=ux81(i1,i2,i3,c)


                 end do
                 end do
                 end do
                 end do
             end if
           endif
        end if


c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=ugradORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=ugradORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=ugradORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=ugradORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=ugradORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=ugradORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(div)
      subroutine divFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b,
     &  ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, ndd1a,ndd1b,
     & ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,deriv, rsxy,
     &  mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "div" == "grad"
!       #Elif "div" == div
c  --- divergence ---
        if( order.eq.2 )then
! divLoop(2)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux22r(i1,i2,i3,ca  )+uy22r(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux22r(i1,i2,i3,ca)+uy22r(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux23r(i1,i2,i3,ca  )+uy23r(i1,i2,i3,ca+1)+uz23r(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux23r(i1,i2,i3,ca)+uy23r(i1,i2,i3,
     & ca+1)+uz23r(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux21r(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux21r(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux22(i1,i2,i3,ca  )+uy22(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux22(i1,i2,i3,ca)+uy22(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux23(i1,i2,i3,ca  )+uy23(i1,i2,i3,ca+1)+uz23(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux23(i1,i2,i3,ca)+uy23(i1,i2,i3,
     & ca+1)+uz23(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux21(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux21(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.4 )then
! divLoop(4)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux42r(i1,i2,i3,ca  )+uy42r(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux42r(i1,i2,i3,ca)+uy42r(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux43r(i1,i2,i3,ca  )+uy43r(i1,i2,i3,ca+1)+uz43r(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux43r(i1,i2,i3,ca)+uy43r(i1,i2,i3,
     & ca+1)+uz43r(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux41r(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux41r(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux42(i1,i2,i3,ca  )+uy42(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux42(i1,i2,i3,ca)+uy42(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux43(i1,i2,i3,ca  )+uy43(i1,i2,i3,ca+1)+uz43(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux43(i1,i2,i3,ca)+uy43(i1,i2,i3,
     & ca+1)+uz43(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux41(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux41(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.6 )then
! divLoop(6)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux62r(i1,i2,i3,ca  )+uy62r(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux62r(i1,i2,i3,ca)+uy62r(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux63r(i1,i2,i3,ca  )+uy63r(i1,i2,i3,ca+1)+uz63r(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux63r(i1,i2,i3,ca)+uy63r(i1,i2,i3,
     & ca+1)+uz63r(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux61r(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux61r(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux62(i1,i2,i3,ca  )+uy62(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux62(i1,i2,i3,ca)+uy62(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux63(i1,i2,i3,ca  )+uy63(i1,i2,i3,ca+1)+uz63(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux63(i1,i2,i3,ca)+uy63(i1,i2,i3,
     & ca+1)+uz63(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux61(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux61(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.8 )then
! divLoop(8)
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux82r(i1,i2,i3,ca  )+uy82r(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux82r(i1,i2,i3,ca)+uy82r(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux83r(i1,i2,i3,ca  )+uy83r(i1,i2,i3,ca+1)+uz83r(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux83r(i1,i2,i3,ca)+uy83r(i1,i2,i3,
     & ca+1)+uz83r(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux81r(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux81r(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux82(i1,i2,i3,ca  )+uy82(i1,i2,i3,ca+1),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux82(i1,i2,i3,ca)+uy82(i1,i2,i3,
     & ca+1)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=ux83(i1,i2,i3,ca  )+uy83(i1,i2,i3,ca+1)+uz83(i1,i2,i3,ca+2),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux83(i1,i2,i3,ca)+uy83(i1,i2,i3,
     & ca+1)+uz83(i1,i2,i3,ca+2)


                 end do
                 end do
                 end do
             else
! loops3nc(deriv(i1,i2,i3,0)=ux81(i1,i2,i3,ca  ),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux81(i1,i2,i3,ca)


                 end do
                 end do
                 end do
             end if
           endif
        end if


c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=udivORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=udivORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=udivORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=udivORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=udivORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=udivORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end
! finiteDifferenceDerivative(vorticity)
      subroutine vorticityFiniteDiffDeriv( nd, nd1a,nd1b,nd2a,nd2b,
     & nd3a,nd3b, ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b, 
     & ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b, ipar, rpar, u,
     & deriv, rsxy, mask )
c ===============================================================
c    Evaluate the difference approximation to a derivative
c
c nd1a,nd1b,nd2a,nd2b,nd3a,nd3b: dimensions for rsxy and mask
c ndu1a,ndu1b,ndu2a,ndu2b,ndu3a,ndu3b,ndu4a,ndu4b :  dimensions for u
c ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,ndd3b,ndd4a,ndd4b :  dimensions for deriv
c rsxy : not used if rectangular
c
c ca,cb : assign components c=ca,..,cb (base 0)
c gridType: 0=rectangular, 1=non-rectangular
c order : order of accuracy
c dr(0:2), dx(0:2) 
c ===============================================================

       implicit none
       integer nd, nd1a,nd1b,nd2a,nd2b,nd3a,nd3b, ndu1a,ndu1b,ndu2a,
     & ndu2b,ndu3a,ndu3b,ndu4a,ndu4b,ndd1a,ndd1b,ndd2a,ndd2b,ndd3a,
     & ndd3b,ndd4a,ndd4b

       real rsxy(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)
       real u(ndu1a:ndu1b,ndu2a:ndu2b,ndu3a:ndu3b,ndu4a:ndu4b)
       real deriv(ndd1a:ndd1b,ndd2a:ndd2b,ndd3a:ndd3b,ndd4a:ndd4b)
       integer mask(nd1a:nd1b,nd2a:nd2b,nd3a:nd3b,1:nd,1:nd)

       real rpar(0:*)
       integer ipar(0:*)

c  ....local variables
       integer i1,i2,i3,kd,c,kdd,kd3,ndc
       real dr(0:2), dx(0:2)
       integer n1a,n1b,n2a,n2b,n3a,n3b, ca,cb, gridType, order

       integer rectangular,curvilinear
       parameter( rectangular=0,curvilinear=1 )

       real rx,ry,rz,sx,sy,sz,tx,ty,tz

       include 'declareDiffOrder2f.h'
       include 'declareDiffOrder4f.h'
       include 'declareDiffOrder6f.h'
       include 'declareDiffOrder8f.h'

c.......statement functions 
c.......statement functions for jacobian
       rx(i1,i2,i3)=rsxy(i1,i2,i3,1,1)
       ry(i1,i2,i3)=rsxy(i1,i2,i3,1,2)
       rz(i1,i2,i3)=rsxy(i1,i2,i3,1,3)
       sx(i1,i2,i3)=rsxy(i1,i2,i3,2,1)
       sy(i1,i2,i3)=rsxy(i1,i2,i3,2,2)
       sz(i1,i2,i3)=rsxy(i1,i2,i3,2,3)
       tx(i1,i2,i3)=rsxy(i1,i2,i3,3,1)
       ty(i1,i2,i3)=rsxy(i1,i2,i3,3,2)
       tz(i1,i2,i3)=rsxy(i1,i2,i3,3,3)

c     The next macro call will define the difference approximation statement functions
! defineDifferenceOrder2Components1(u,RX)

!        #If "RX" == "RX"
       d12(kd) = 1./(2.*dr(kd))
       d22(kd) = 1./(dr(kd)**2)

       ur2(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*d12(0)
       us2(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*d12(1)
       ut2(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*d12(2)

       urr2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-1,
     & i2,i3,kd)) )*d22(0)
       uss2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,i2-
     & 1,i3,kd)) )*d22(1)
       urs2(i1,i2,i3,kd)=(ur2(i1,i2+1,i3,kd)-ur2(i1,i2-1,i3,kd))*d12(1)
       utt2(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,i2,
     & i3-1,kd)) )*d22(2)
       urt2(i1,i2,i3,kd)=(ur2(i1,i2,i3+1,kd)-ur2(i1,i2,i3-1,kd))*d12(2)
       ust2(i1,i2,i3,kd)=(us2(i1,i2,i3+1,kd)-us2(i1,i2,i3-1,kd))*d12(2)

!        #If "RX" == "RX"
       rxr2(i1,i2,i3)=(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))*d12(0)
       rxs2(i1,i2,i3)=(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))*d12(1)
       rxt2(i1,i2,i3)=(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))*d12(2)
       ryr2(i1,i2,i3)=(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))*d12(0)
       rys2(i1,i2,i3)=(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))*d12(1)
       ryt2(i1,i2,i3)=(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))*d12(2)
       rzr2(i1,i2,i3)=(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))*d12(0)
       rzs2(i1,i2,i3)=(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))*d12(1)
       rzt2(i1,i2,i3)=(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))*d12(2)
       sxr2(i1,i2,i3)=(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))*d12(0)
       sxs2(i1,i2,i3)=(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))*d12(1)
       sxt2(i1,i2,i3)=(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))*d12(2)
       syr2(i1,i2,i3)=(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))*d12(0)
       sys2(i1,i2,i3)=(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))*d12(1)
       syt2(i1,i2,i3)=(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))*d12(2)
       szr2(i1,i2,i3)=(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))*d12(0)
       szs2(i1,i2,i3)=(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))*d12(1)
       szt2(i1,i2,i3)=(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))*d12(2)
       txr2(i1,i2,i3)=(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))*d12(0)
       txs2(i1,i2,i3)=(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))*d12(1)
       txt2(i1,i2,i3)=(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))*d12(2)
       tyr2(i1,i2,i3)=(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))*d12(0)
       tys2(i1,i2,i3)=(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))*d12(1)
       tyt2(i1,i2,i3)=(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))*d12(2)
       tzr2(i1,i2,i3)=(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))*d12(0)
       tzs2(i1,i2,i3)=(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))*d12(1)
       tzt2(i1,i2,i3)=(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))*d12(2)

       ux21(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)
       uy21(i1,i2,i3,kd)=0
       uz21(i1,i2,i3,kd)=0

       ux22(i1,i2,i3,kd)= rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uy22(i1,i2,i3,kd)= ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)
       uz22(i1,i2,i3,kd)=0
       ux23(i1,i2,i3,kd)=rx(i1,i2,i3)*ur2(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tx(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uy23(i1,i2,i3,kd)=ry(i1,i2,i3)*ur2(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+ty(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uz23(i1,i2,i3,kd)=rz(i1,i2,i3)*ur2(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tz(i1,i2,i3)*ut2(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx21(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)
       rxx22(i1,i2,i3)= rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxy22(i1,i2,i3)= ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)
       rxx23(i1,i2,i3)=rx(i1,i2,i3)*rxr2(i1,i2,i3)+sx(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt2(i1,i2,i3)
       rxy23(i1,i2,i3)=ry(i1,i2,i3)*rxr2(i1,i2,i3)+sy(i1,i2,i3)*rxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt2(i1,i2,i3)
       rxz23(i1,i2,i3)=rz(i1,i2,i3)*rxr2(i1,i2,i3)+sz(i1,i2,i3)*rxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt2(i1,i2,i3)
       ryx22(i1,i2,i3)= rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryy22(i1,i2,i3)= ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)
       ryx23(i1,i2,i3)=rx(i1,i2,i3)*ryr2(i1,i2,i3)+sx(i1,i2,i3)*rys2(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt2(i1,i2,i3)
       ryy23(i1,i2,i3)=ry(i1,i2,i3)*ryr2(i1,i2,i3)+sy(i1,i2,i3)*rys2(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt2(i1,i2,i3)
       ryz23(i1,i2,i3)=rz(i1,i2,i3)*ryr2(i1,i2,i3)+sz(i1,i2,i3)*rys2(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt2(i1,i2,i3)
       rzx22(i1,i2,i3)= rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzy22(i1,i2,i3)= ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)
       rzx23(i1,i2,i3)=rx(i1,i2,i3)*rzr2(i1,i2,i3)+sx(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt2(i1,i2,i3)
       rzy23(i1,i2,i3)=ry(i1,i2,i3)*rzr2(i1,i2,i3)+sy(i1,i2,i3)*rzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt2(i1,i2,i3)
       rzz23(i1,i2,i3)=rz(i1,i2,i3)*rzr2(i1,i2,i3)+sz(i1,i2,i3)*rzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt2(i1,i2,i3)
       sxx22(i1,i2,i3)= rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxy22(i1,i2,i3)= ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)
       sxx23(i1,i2,i3)=rx(i1,i2,i3)*sxr2(i1,i2,i3)+sx(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt2(i1,i2,i3)
       sxy23(i1,i2,i3)=ry(i1,i2,i3)*sxr2(i1,i2,i3)+sy(i1,i2,i3)*sxs2(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt2(i1,i2,i3)
       sxz23(i1,i2,i3)=rz(i1,i2,i3)*sxr2(i1,i2,i3)+sz(i1,i2,i3)*sxs2(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt2(i1,i2,i3)
       syx22(i1,i2,i3)= rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syy22(i1,i2,i3)= ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)
       syx23(i1,i2,i3)=rx(i1,i2,i3)*syr2(i1,i2,i3)+sx(i1,i2,i3)*sys2(
     & i1,i2,i3)+tx(i1,i2,i3)*syt2(i1,i2,i3)
       syy23(i1,i2,i3)=ry(i1,i2,i3)*syr2(i1,i2,i3)+sy(i1,i2,i3)*sys2(
     & i1,i2,i3)+ty(i1,i2,i3)*syt2(i1,i2,i3)
       syz23(i1,i2,i3)=rz(i1,i2,i3)*syr2(i1,i2,i3)+sz(i1,i2,i3)*sys2(
     & i1,i2,i3)+tz(i1,i2,i3)*syt2(i1,i2,i3)
       szx22(i1,i2,i3)= rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szy22(i1,i2,i3)= ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)
       szx23(i1,i2,i3)=rx(i1,i2,i3)*szr2(i1,i2,i3)+sx(i1,i2,i3)*szs2(
     & i1,i2,i3)+tx(i1,i2,i3)*szt2(i1,i2,i3)
       szy23(i1,i2,i3)=ry(i1,i2,i3)*szr2(i1,i2,i3)+sy(i1,i2,i3)*szs2(
     & i1,i2,i3)+ty(i1,i2,i3)*szt2(i1,i2,i3)
       szz23(i1,i2,i3)=rz(i1,i2,i3)*szr2(i1,i2,i3)+sz(i1,i2,i3)*szs2(
     & i1,i2,i3)+tz(i1,i2,i3)*szt2(i1,i2,i3)
       txx22(i1,i2,i3)= rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txy22(i1,i2,i3)= ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)
       txx23(i1,i2,i3)=rx(i1,i2,i3)*txr2(i1,i2,i3)+sx(i1,i2,i3)*txs2(
     & i1,i2,i3)+tx(i1,i2,i3)*txt2(i1,i2,i3)
       txy23(i1,i2,i3)=ry(i1,i2,i3)*txr2(i1,i2,i3)+sy(i1,i2,i3)*txs2(
     & i1,i2,i3)+ty(i1,i2,i3)*txt2(i1,i2,i3)
       txz23(i1,i2,i3)=rz(i1,i2,i3)*txr2(i1,i2,i3)+sz(i1,i2,i3)*txs2(
     & i1,i2,i3)+tz(i1,i2,i3)*txt2(i1,i2,i3)
       tyx22(i1,i2,i3)= rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyy22(i1,i2,i3)= ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)
       tyx23(i1,i2,i3)=rx(i1,i2,i3)*tyr2(i1,i2,i3)+sx(i1,i2,i3)*tys2(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt2(i1,i2,i3)
       tyy23(i1,i2,i3)=ry(i1,i2,i3)*tyr2(i1,i2,i3)+sy(i1,i2,i3)*tys2(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt2(i1,i2,i3)
       tyz23(i1,i2,i3)=rz(i1,i2,i3)*tyr2(i1,i2,i3)+sz(i1,i2,i3)*tys2(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt2(i1,i2,i3)
       tzx22(i1,i2,i3)= rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzy22(i1,i2,i3)= ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)
       tzx23(i1,i2,i3)=rx(i1,i2,i3)*tzr2(i1,i2,i3)+sx(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt2(i1,i2,i3)
       tzy23(i1,i2,i3)=ry(i1,i2,i3)*tzr2(i1,i2,i3)+sy(i1,i2,i3)*tzs2(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt2(i1,i2,i3)
       tzz23(i1,i2,i3)=rz(i1,i2,i3)*tzr2(i1,i2,i3)+sz(i1,i2,i3)*tzs2(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt2(i1,i2,i3)

       uxx21(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(rxx22(
     & i1,i2,i3))*ur2(i1,i2,i3,kd)
       uyy21(i1,i2,i3,kd)=0
       uxy21(i1,i2,i3,kd)=0
       uxz21(i1,i2,i3,kd)=0
       uyz21(i1,i2,i3,kd)=0
       uzz21(i1,i2,i3,kd)=0
       ulaplacian21(i1,i2,i3,kd)=uxx21(i1,i2,i3,kd)
       uxx22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uyy22(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss2(i1,i2,i3,kd)+(ryy22(i1,i2,i3))*ur2(i1,i2,i3,kd)+(syy22(i1,
     & i2,i3))*us2(i1,i2,i3,kd)
       uxy22(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs2(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+rxy22(i1,
     & i2,i3)*ur2(i1,i2,i3,kd)+sxy22(i1,i2,i3)*us2(i1,i2,i3,kd)
       uxz22(i1,i2,i3,kd)=0
       uyz22(i1,i2,i3,kd)=0
       uzz22(i1,i2,i3,kd)=0
       ulaplacian22(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss2(i1,i2,i3,kd)+(rxx22(i1,i2,i3)+ryy22(i1,i2,i3))*ur2(i1,
     & i2,i3,kd)+(sxx22(i1,i2,i3)+syy22(i1,i2,i3))*us2(i1,i2,i3,kd)
       uxx23(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rxx23(i1,i2,i3)*ur2(i1,i2,i3,kd)+sxx23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+txx23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyy23(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+ryy23(i1,i2,i3)*ur2(i1,i2,i3,kd)+syy23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tyy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uzz23(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr2(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss2(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt2(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs2(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt2(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust2(
     & i1,i2,i3,kd)+rzz23(i1,i2,i3)*ur2(i1,i2,i3,kd)+szz23(i1,i2,i3)*
     & us2(i1,i2,i3,kd)+tzz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxy23(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxy23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxy23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txy23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uxz23(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs2(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust2(i1,i2,i3,kd)+rxz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+sxz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & txz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       uyz23(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr2(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss2(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt2(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs2(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt2(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust2(i1,i2,i3,kd)+ryz23(
     & i1,i2,i3)*ur2(i1,i2,i3,kd)+syz23(i1,i2,i3)*us2(i1,i2,i3,kd)+
     & tyz23(i1,i2,i3)*ut2(i1,i2,i3,kd)
       ulaplacian23(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr2(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss2(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs2(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt2(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust2(i1,i2,i3,kd)+(rxx23(i1,i2,i3)+ryy23(i1,
     & i2,i3)+rzz23(i1,i2,i3))*ur2(i1,i2,i3,kd)+(sxx23(i1,i2,i3)+
     & syy23(i1,i2,i3)+szz23(i1,i2,i3))*us2(i1,i2,i3,kd)+(txx23(i1,i2,
     & i3)+tyy23(i1,i2,i3)+tzz23(i1,i2,i3))*ut2(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h12(kd) = 1./(2.*dx(kd))
       h22(kd) = 1./(dx(kd)**2)

       ux23r(i1,i2,i3,kd)=(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))*h12(0)
       uy23r(i1,i2,i3,kd)=(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))*h12(1)
       uz23r(i1,i2,i3,kd)=(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))*h12(2)

       uxx23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1+1,i2,i3,kd)+u(i1-
     & 1,i2,i3,kd)) )*h22(0)
       uyy23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2+1,i3,kd)+u(i1,
     & i2-1,i3,kd)) )*h22(1)
       uxy23r(i1,i2,i3,kd)=(ux23r(i1,i2+1,i3,kd)-ux23r(i1,i2-1,i3,kd))*
     & h12(1)
       uzz23r(i1,i2,i3,kd)=(-2.*u(i1,i2,i3,kd)+(u(i1,i2,i3+1,kd)+u(i1,
     & i2,i3-1,kd)) )*h22(2)
       uxz23r(i1,i2,i3,kd)=(ux23r(i1,i2,i3+1,kd)-ux23r(i1,i2,i3-1,kd))*
     & h12(2)
       uyz23r(i1,i2,i3,kd)=(uy23r(i1,i2,i3+1,kd)-uy23r(i1,i2,i3-1,kd))*
     & h12(2)

       ux21r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy21r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz21r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx21r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy21r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz21r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy21r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz21r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz21r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian21r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)
       ux22r(i1,i2,i3,kd)= ux23r(i1,i2,i3,kd)
       uy22r(i1,i2,i3,kd)= uy23r(i1,i2,i3,kd)
       uz22r(i1,i2,i3,kd)= uz23r(i1,i2,i3,kd)
       uxx22r(i1,i2,i3,kd)= uxx23r(i1,i2,i3,kd)
       uyy22r(i1,i2,i3,kd)= uyy23r(i1,i2,i3,kd)
       uzz22r(i1,i2,i3,kd)= uzz23r(i1,i2,i3,kd)
       uxy22r(i1,i2,i3,kd)= uxy23r(i1,i2,i3,kd)
       uxz22r(i1,i2,i3,kd)= uxz23r(i1,i2,i3,kd)
       uyz22r(i1,i2,i3,kd)= uyz23r(i1,i2,i3,kd)
       ulaplacian22r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)
       ulaplacian23r(i1,i2,i3,kd)=uxx23r(i1,i2,i3,kd)+uyy23r(i1,i2,i3,
     & kd)+uzz23r(i1,i2,i3,kd)
! defineDifferenceOrder4Components1(u,RX)

!        #If "RX" == "RX"
       d14(kd) = 1./(12.*dr(kd))
       d24(kd) = 1./(12.*dr(kd)**2)

       ur4(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(i1+
     & 2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*d14(0)
       us4(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(i1,
     & i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*d14(1)
       ut4(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(i1,
     & i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*d14(2)

       urr4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+u(
     & i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*d24(0)
       uss4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+u(
     & i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*d24(1)
       utt4(i1,i2,i3,kd)=(-30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+u(
     & i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*d24(2)
       urs4(i1,i2,i3,kd)=(8.*(ur4(i1,i2+1,i3,kd)-ur4(i1,i2-1,i3,kd))-(
     & ur4(i1,i2+2,i3,kd)-ur4(i1,i2-2,i3,kd)))*d14(1)
       urt4(i1,i2,i3,kd)=(8.*(ur4(i1,i2,i3+1,kd)-ur4(i1,i2,i3-1,kd))-(
     & ur4(i1,i2,i3+2,kd)-ur4(i1,i2,i3-2,kd)))*d14(2)
       ust4(i1,i2,i3,kd)=(8.*(us4(i1,i2,i3+1,kd)-us4(i1,i2,i3-1,kd))-(
     & us4(i1,i2,i3+2,kd)-us4(i1,i2,i3-2,kd)))*d14(2)

!        #If "RX" == "RX"
       rxr4(i1,i2,i3)=(8.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-(rx(i1+2,i2,
     & i3)-rx(i1-2,i2,i3)))*d14(0)
       rxs4(i1,i2,i3)=(8.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-(rx(i1,i2+2,
     & i3)-rx(i1,i2-2,i3)))*d14(1)
       rxt4(i1,i2,i3)=(8.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-(rx(i1,i2,i3+
     & 2)-rx(i1,i2,i3-2)))*d14(2)
       ryr4(i1,i2,i3)=(8.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-(ry(i1+2,i2,
     & i3)-ry(i1-2,i2,i3)))*d14(0)
       rys4(i1,i2,i3)=(8.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-(ry(i1,i2+2,
     & i3)-ry(i1,i2-2,i3)))*d14(1)
       ryt4(i1,i2,i3)=(8.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-(ry(i1,i2,i3+
     & 2)-ry(i1,i2,i3-2)))*d14(2)
       rzr4(i1,i2,i3)=(8.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-(rz(i1+2,i2,
     & i3)-rz(i1-2,i2,i3)))*d14(0)
       rzs4(i1,i2,i3)=(8.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-(rz(i1,i2+2,
     & i3)-rz(i1,i2-2,i3)))*d14(1)
       rzt4(i1,i2,i3)=(8.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-(rz(i1,i2,i3+
     & 2)-rz(i1,i2,i3-2)))*d14(2)
       sxr4(i1,i2,i3)=(8.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-(sx(i1+2,i2,
     & i3)-sx(i1-2,i2,i3)))*d14(0)
       sxs4(i1,i2,i3)=(8.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-(sx(i1,i2+2,
     & i3)-sx(i1,i2-2,i3)))*d14(1)
       sxt4(i1,i2,i3)=(8.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-(sx(i1,i2,i3+
     & 2)-sx(i1,i2,i3-2)))*d14(2)
       syr4(i1,i2,i3)=(8.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-(sy(i1+2,i2,
     & i3)-sy(i1-2,i2,i3)))*d14(0)
       sys4(i1,i2,i3)=(8.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-(sy(i1,i2+2,
     & i3)-sy(i1,i2-2,i3)))*d14(1)
       syt4(i1,i2,i3)=(8.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-(sy(i1,i2,i3+
     & 2)-sy(i1,i2,i3-2)))*d14(2)
       szr4(i1,i2,i3)=(8.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-(sz(i1+2,i2,
     & i3)-sz(i1-2,i2,i3)))*d14(0)
       szs4(i1,i2,i3)=(8.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-(sz(i1,i2+2,
     & i3)-sz(i1,i2-2,i3)))*d14(1)
       szt4(i1,i2,i3)=(8.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-(sz(i1,i2,i3+
     & 2)-sz(i1,i2,i3-2)))*d14(2)
       txr4(i1,i2,i3)=(8.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-(tx(i1+2,i2,
     & i3)-tx(i1-2,i2,i3)))*d14(0)
       txs4(i1,i2,i3)=(8.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-(tx(i1,i2+2,
     & i3)-tx(i1,i2-2,i3)))*d14(1)
       txt4(i1,i2,i3)=(8.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-(tx(i1,i2,i3+
     & 2)-tx(i1,i2,i3-2)))*d14(2)
       tyr4(i1,i2,i3)=(8.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-(ty(i1+2,i2,
     & i3)-ty(i1-2,i2,i3)))*d14(0)
       tys4(i1,i2,i3)=(8.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-(ty(i1,i2+2,
     & i3)-ty(i1,i2-2,i3)))*d14(1)
       tyt4(i1,i2,i3)=(8.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-(ty(i1,i2,i3+
     & 2)-ty(i1,i2,i3-2)))*d14(2)
       tzr4(i1,i2,i3)=(8.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-(tz(i1+2,i2,
     & i3)-tz(i1-2,i2,i3)))*d14(0)
       tzs4(i1,i2,i3)=(8.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-(tz(i1,i2+2,
     & i3)-tz(i1,i2-2,i3)))*d14(1)
       tzt4(i1,i2,i3)=(8.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-(tz(i1,i2,i3+
     & 2)-tz(i1,i2,i3-2)))*d14(2)

       ux41(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)
       uy41(i1,i2,i3,kd)=0
       uz41(i1,i2,i3,kd)=0

       ux42(i1,i2,i3,kd)= rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uy42(i1,i2,i3,kd)= ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)
       uz42(i1,i2,i3,kd)=0
       ux43(i1,i2,i3,kd)=rx(i1,i2,i3)*ur4(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tx(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uy43(i1,i2,i3,kd)=ry(i1,i2,i3)*ur4(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+ty(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uz43(i1,i2,i3,kd)=rz(i1,i2,i3)*ur4(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tz(i1,i2,i3)*ut4(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx41(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)
       rxx42(i1,i2,i3)= rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxy42(i1,i2,i3)= ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)
       rxx43(i1,i2,i3)=rx(i1,i2,i3)*rxr4(i1,i2,i3)+sx(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt4(i1,i2,i3)
       rxy43(i1,i2,i3)=ry(i1,i2,i3)*rxr4(i1,i2,i3)+sy(i1,i2,i3)*rxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt4(i1,i2,i3)
       rxz43(i1,i2,i3)=rz(i1,i2,i3)*rxr4(i1,i2,i3)+sz(i1,i2,i3)*rxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt4(i1,i2,i3)
       ryx42(i1,i2,i3)= rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryy42(i1,i2,i3)= ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)
       ryx43(i1,i2,i3)=rx(i1,i2,i3)*ryr4(i1,i2,i3)+sx(i1,i2,i3)*rys4(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt4(i1,i2,i3)
       ryy43(i1,i2,i3)=ry(i1,i2,i3)*ryr4(i1,i2,i3)+sy(i1,i2,i3)*rys4(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt4(i1,i2,i3)
       ryz43(i1,i2,i3)=rz(i1,i2,i3)*ryr4(i1,i2,i3)+sz(i1,i2,i3)*rys4(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt4(i1,i2,i3)
       rzx42(i1,i2,i3)= rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzy42(i1,i2,i3)= ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)
       rzx43(i1,i2,i3)=rx(i1,i2,i3)*rzr4(i1,i2,i3)+sx(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt4(i1,i2,i3)
       rzy43(i1,i2,i3)=ry(i1,i2,i3)*rzr4(i1,i2,i3)+sy(i1,i2,i3)*rzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt4(i1,i2,i3)
       rzz43(i1,i2,i3)=rz(i1,i2,i3)*rzr4(i1,i2,i3)+sz(i1,i2,i3)*rzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt4(i1,i2,i3)
       sxx42(i1,i2,i3)= rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxy42(i1,i2,i3)= ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)
       sxx43(i1,i2,i3)=rx(i1,i2,i3)*sxr4(i1,i2,i3)+sx(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt4(i1,i2,i3)
       sxy43(i1,i2,i3)=ry(i1,i2,i3)*sxr4(i1,i2,i3)+sy(i1,i2,i3)*sxs4(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt4(i1,i2,i3)
       sxz43(i1,i2,i3)=rz(i1,i2,i3)*sxr4(i1,i2,i3)+sz(i1,i2,i3)*sxs4(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt4(i1,i2,i3)
       syx42(i1,i2,i3)= rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syy42(i1,i2,i3)= ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)
       syx43(i1,i2,i3)=rx(i1,i2,i3)*syr4(i1,i2,i3)+sx(i1,i2,i3)*sys4(
     & i1,i2,i3)+tx(i1,i2,i3)*syt4(i1,i2,i3)
       syy43(i1,i2,i3)=ry(i1,i2,i3)*syr4(i1,i2,i3)+sy(i1,i2,i3)*sys4(
     & i1,i2,i3)+ty(i1,i2,i3)*syt4(i1,i2,i3)
       syz43(i1,i2,i3)=rz(i1,i2,i3)*syr4(i1,i2,i3)+sz(i1,i2,i3)*sys4(
     & i1,i2,i3)+tz(i1,i2,i3)*syt4(i1,i2,i3)
       szx42(i1,i2,i3)= rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szy42(i1,i2,i3)= ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)
       szx43(i1,i2,i3)=rx(i1,i2,i3)*szr4(i1,i2,i3)+sx(i1,i2,i3)*szs4(
     & i1,i2,i3)+tx(i1,i2,i3)*szt4(i1,i2,i3)
       szy43(i1,i2,i3)=ry(i1,i2,i3)*szr4(i1,i2,i3)+sy(i1,i2,i3)*szs4(
     & i1,i2,i3)+ty(i1,i2,i3)*szt4(i1,i2,i3)
       szz43(i1,i2,i3)=rz(i1,i2,i3)*szr4(i1,i2,i3)+sz(i1,i2,i3)*szs4(
     & i1,i2,i3)+tz(i1,i2,i3)*szt4(i1,i2,i3)
       txx42(i1,i2,i3)= rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txy42(i1,i2,i3)= ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)
       txx43(i1,i2,i3)=rx(i1,i2,i3)*txr4(i1,i2,i3)+sx(i1,i2,i3)*txs4(
     & i1,i2,i3)+tx(i1,i2,i3)*txt4(i1,i2,i3)
       txy43(i1,i2,i3)=ry(i1,i2,i3)*txr4(i1,i2,i3)+sy(i1,i2,i3)*txs4(
     & i1,i2,i3)+ty(i1,i2,i3)*txt4(i1,i2,i3)
       txz43(i1,i2,i3)=rz(i1,i2,i3)*txr4(i1,i2,i3)+sz(i1,i2,i3)*txs4(
     & i1,i2,i3)+tz(i1,i2,i3)*txt4(i1,i2,i3)
       tyx42(i1,i2,i3)= rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyy42(i1,i2,i3)= ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)
       tyx43(i1,i2,i3)=rx(i1,i2,i3)*tyr4(i1,i2,i3)+sx(i1,i2,i3)*tys4(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt4(i1,i2,i3)
       tyy43(i1,i2,i3)=ry(i1,i2,i3)*tyr4(i1,i2,i3)+sy(i1,i2,i3)*tys4(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt4(i1,i2,i3)
       tyz43(i1,i2,i3)=rz(i1,i2,i3)*tyr4(i1,i2,i3)+sz(i1,i2,i3)*tys4(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt4(i1,i2,i3)
       tzx42(i1,i2,i3)= rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzy42(i1,i2,i3)= ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)
       tzx43(i1,i2,i3)=rx(i1,i2,i3)*tzr4(i1,i2,i3)+sx(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt4(i1,i2,i3)
       tzy43(i1,i2,i3)=ry(i1,i2,i3)*tzr4(i1,i2,i3)+sy(i1,i2,i3)*tzs4(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt4(i1,i2,i3)
       tzz43(i1,i2,i3)=rz(i1,i2,i3)*tzr4(i1,i2,i3)+sz(i1,i2,i3)*tzs4(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt4(i1,i2,i3)

       uxx41(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(rxx42(
     & i1,i2,i3))*ur4(i1,i2,i3,kd)
       uyy41(i1,i2,i3,kd)=0
       uxy41(i1,i2,i3,kd)=0
       uxz41(i1,i2,i3,kd)=0
       uyz41(i1,i2,i3,kd)=0
       uzz41(i1,i2,i3,kd)=0
       ulaplacian41(i1,i2,i3,kd)=uxx41(i1,i2,i3,kd)
       uxx42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uyy42(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss4(i1,i2,i3,kd)+(ryy42(i1,i2,i3))*ur4(i1,i2,i3,kd)+(syy42(i1,
     & i2,i3))*us4(i1,i2,i3,kd)
       uxy42(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs4(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+rxy42(i1,
     & i2,i3)*ur4(i1,i2,i3,kd)+sxy42(i1,i2,i3)*us4(i1,i2,i3,kd)
       uxz42(i1,i2,i3,kd)=0
       uyz42(i1,i2,i3,kd)=0
       uzz42(i1,i2,i3,kd)=0
       ulaplacian42(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss4(i1,i2,i3,kd)+(rxx42(i1,i2,i3)+ryy42(i1,i2,i3))*ur4(i1,
     & i2,i3,kd)+(sxx42(i1,i2,i3)+syy42(i1,i2,i3))*us4(i1,i2,i3,kd)
       uxx43(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rxx43(i1,i2,i3)*ur4(i1,i2,i3,kd)+sxx43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+txx43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyy43(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+ryy43(i1,i2,i3)*ur4(i1,i2,i3,kd)+syy43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tyy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uzz43(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr4(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss4(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt4(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs4(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt4(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust4(
     & i1,i2,i3,kd)+rzz43(i1,i2,i3)*ur4(i1,i2,i3,kd)+szz43(i1,i2,i3)*
     & us4(i1,i2,i3,kd)+tzz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxy43(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxy43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxy43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txy43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uxz43(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs4(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust4(i1,i2,i3,kd)+rxz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+sxz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & txz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       uyz43(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr4(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss4(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt4(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs4(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt4(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust4(i1,i2,i3,kd)+ryz43(
     & i1,i2,i3)*ur4(i1,i2,i3,kd)+syz43(i1,i2,i3)*us4(i1,i2,i3,kd)+
     & tyz43(i1,i2,i3)*ut4(i1,i2,i3,kd)
       ulaplacian43(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr4(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss4(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs4(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt4(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust4(i1,i2,i3,kd)+(rxx43(i1,i2,i3)+ryy43(i1,
     & i2,i3)+rzz43(i1,i2,i3))*ur4(i1,i2,i3,kd)+(sxx43(i1,i2,i3)+
     & syy43(i1,i2,i3)+szz43(i1,i2,i3))*us4(i1,i2,i3,kd)+(txx43(i1,i2,
     & i3)+tyy43(i1,i2,i3)+tzz43(i1,i2,i3))*ut4(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h41(kd) = 1./(12.*dx(kd))
       h42(kd) = 1./(12.*dx(kd)**2)
       ux43r(i1,i2,i3,kd)=(8.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd)))*h41(0)
       uy43r(i1,i2,i3,kd)=(8.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd)))*h41(1)
       uz43r(i1,i2,i3,kd)=(8.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd)))*h41(2)
       uxx43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd)) )*h42(0)
       uyy43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd)) )*h42(1)
       uzz43r(i1,i2,i3,kd)=( -30.*u(i1,i2,i3,kd)+16.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd)) )*h42(2)
       uxy43r(i1,i2,i3,kd)=( (u(i1+2,i2+2,i3,kd)-u(i1-2,i2+2,i3,kd)- u(
     & i1+2,i2-2,i3,kd)+u(i1-2,i2-2,i3,kd)) +8.*(u(i1-1,i2+2,i3,kd)-u(
     & i1-1,i2-2,i3,kd)-u(i1+1,i2+2,i3,kd)+u(i1+1,i2-2,i3,kd) +u(i1+2,
     & i2-1,i3,kd)-u(i1-2,i2-1,i3,kd)-u(i1+2,i2+1,i3,kd)+u(i1-2,i2+1,
     & i3,kd))+64.*(u(i1+1,i2+1,i3,kd)-u(i1-1,i2+1,i3,kd)- u(i1+1,i2-
     & 1,i3,kd)+u(i1-1,i2-1,i3,kd)))*(h41(0)*h41(1))
       uxz43r(i1,i2,i3,kd)=( (u(i1+2,i2,i3+2,kd)-u(i1-2,i2,i3+2,kd)-u(
     & i1+2,i2,i3-2,kd)+u(i1-2,i2,i3-2,kd)) +8.*(u(i1-1,i2,i3+2,kd)-u(
     & i1-1,i2,i3-2,kd)-u(i1+1,i2,i3+2,kd)+u(i1+1,i2,i3-2,kd) +u(i1+2,
     & i2,i3-1,kd)-u(i1-2,i2,i3-1,kd)- u(i1+2,i2,i3+1,kd)+u(i1-2,i2,
     & i3+1,kd)) +64.*(u(i1+1,i2,i3+1,kd)-u(i1-1,i2,i3+1,kd)-u(i1+1,
     & i2,i3-1,kd)+u(i1-1,i2,i3-1,kd)) )*(h41(0)*h41(2))
       uyz43r(i1,i2,i3,kd)=( (u(i1,i2+2,i3+2,kd)-u(i1,i2-2,i3+2,kd)-u(
     & i1,i2+2,i3-2,kd)+u(i1,i2-2,i3-2,kd)) +8.*(u(i1,i2-1,i3+2,kd)-u(
     & i1,i2-1,i3-2,kd)-u(i1,i2+1,i3+2,kd)+u(i1,i2+1,i3-2,kd) +u(i1,
     & i2+2,i3-1,kd)-u(i1,i2-2,i3-1,kd)-u(i1,i2+2,i3+1,kd)+u(i1,i2-2,
     & i3+1,kd)) +64.*(u(i1,i2+1,i3+1,kd)-u(i1,i2-1,i3+1,kd)-u(i1,i2+
     & 1,i3-1,kd)+u(i1,i2-1,i3-1,kd)) )*(h41(1)*h41(2))
       ux41r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy41r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz41r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx41r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy41r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz41r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy41r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz41r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz41r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian41r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)
       ux42r(i1,i2,i3,kd)= ux43r(i1,i2,i3,kd)
       uy42r(i1,i2,i3,kd)= uy43r(i1,i2,i3,kd)
       uz42r(i1,i2,i3,kd)= uz43r(i1,i2,i3,kd)
       uxx42r(i1,i2,i3,kd)= uxx43r(i1,i2,i3,kd)
       uyy42r(i1,i2,i3,kd)= uyy43r(i1,i2,i3,kd)
       uzz42r(i1,i2,i3,kd)= uzz43r(i1,i2,i3,kd)
       uxy42r(i1,i2,i3,kd)= uxy43r(i1,i2,i3,kd)
       uxz42r(i1,i2,i3,kd)= uxz43r(i1,i2,i3,kd)
       uyz42r(i1,i2,i3,kd)= uyz43r(i1,i2,i3,kd)
       ulaplacian42r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)
       ulaplacian43r(i1,i2,i3,kd)=uxx43r(i1,i2,i3,kd)+uyy43r(i1,i2,i3,
     & kd)+uzz43r(i1,i2,i3,kd)
! defineDifferenceOrder6Components1(u,RX)

!        #If "RX" == "RX"
       d16(kd) = 1./(60.*dr(kd))
       d26(kd) = 1./(180.*dr(kd)**2)

       ur6(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(u(
     & i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*d16(0)
       us6(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(u(
     & i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*d16(1)
       ut6(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(u(
     & i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,i3-
     & 3,kd)))*d16(2)

       urr6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)+
     & u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*d26(0)
       uss6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)+
     & u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*d26(1)
       utt6(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)+
     & u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*d26(2)
       urs6(i1,i2,i3,kd)=(45.*(ur6(i1,i2+1,i3,kd)-ur6(i1,i2-1,i3,kd))-
     & 9.*(ur6(i1,i2+2,i3,kd)-ur6(i1,i2-2,i3,kd))+(ur6(i1,i2+3,i3,kd)-
     & ur6(i1,i2-3,i3,kd)))*d16(1)
       urt6(i1,i2,i3,kd)=(45.*(ur6(i1,i2,i3+1,kd)-ur6(i1,i2,i3-1,kd))-
     & 9.*(ur6(i1,i2,i3+2,kd)-ur6(i1,i2,i3-2,kd))+(ur6(i1,i2,i3+3,kd)-
     & ur6(i1,i2,i3-3,kd)))*d16(2)
       ust6(i1,i2,i3,kd)=(45.*(us6(i1,i2,i3+1,kd)-us6(i1,i2,i3-1,kd))-
     & 9.*(us6(i1,i2,i3+2,kd)-us6(i1,i2,i3-2,kd))+(us6(i1,i2,i3+3,kd)-
     & us6(i1,i2,i3-3,kd)))*d16(2)

!        #If "RX" == "RX"
       rxr6(i1,i2,i3)=(45.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-9.*(rx(i1+2,
     & i2,i3)-rx(i1-2,i2,i3))+(rx(i1+3,i2,i3)-rx(i1-3,i2,i3)))*d16(0)
       rxs6(i1,i2,i3)=(45.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-9.*(rx(i1,
     & i2+2,i3)-rx(i1,i2-2,i3))+(rx(i1,i2+3,i3)-rx(i1,i2-3,i3)))*d16(
     & 1)
       rxt6(i1,i2,i3)=(45.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-9.*(rx(i1,
     & i2,i3+2)-rx(i1,i2,i3-2))+(rx(i1,i2,i3+3)-rx(i1,i2,i3-3)))*d16(
     & 2)
       ryr6(i1,i2,i3)=(45.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-9.*(ry(i1+2,
     & i2,i3)-ry(i1-2,i2,i3))+(ry(i1+3,i2,i3)-ry(i1-3,i2,i3)))*d16(0)
       rys6(i1,i2,i3)=(45.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-9.*(ry(i1,
     & i2+2,i3)-ry(i1,i2-2,i3))+(ry(i1,i2+3,i3)-ry(i1,i2-3,i3)))*d16(
     & 1)
       ryt6(i1,i2,i3)=(45.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-9.*(ry(i1,
     & i2,i3+2)-ry(i1,i2,i3-2))+(ry(i1,i2,i3+3)-ry(i1,i2,i3-3)))*d16(
     & 2)
       rzr6(i1,i2,i3)=(45.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-9.*(rz(i1+2,
     & i2,i3)-rz(i1-2,i2,i3))+(rz(i1+3,i2,i3)-rz(i1-3,i2,i3)))*d16(0)
       rzs6(i1,i2,i3)=(45.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-9.*(rz(i1,
     & i2+2,i3)-rz(i1,i2-2,i3))+(rz(i1,i2+3,i3)-rz(i1,i2-3,i3)))*d16(
     & 1)
       rzt6(i1,i2,i3)=(45.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-9.*(rz(i1,
     & i2,i3+2)-rz(i1,i2,i3-2))+(rz(i1,i2,i3+3)-rz(i1,i2,i3-3)))*d16(
     & 2)
       sxr6(i1,i2,i3)=(45.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-9.*(sx(i1+2,
     & i2,i3)-sx(i1-2,i2,i3))+(sx(i1+3,i2,i3)-sx(i1-3,i2,i3)))*d16(0)
       sxs6(i1,i2,i3)=(45.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-9.*(sx(i1,
     & i2+2,i3)-sx(i1,i2-2,i3))+(sx(i1,i2+3,i3)-sx(i1,i2-3,i3)))*d16(
     & 1)
       sxt6(i1,i2,i3)=(45.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-9.*(sx(i1,
     & i2,i3+2)-sx(i1,i2,i3-2))+(sx(i1,i2,i3+3)-sx(i1,i2,i3-3)))*d16(
     & 2)
       syr6(i1,i2,i3)=(45.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-9.*(sy(i1+2,
     & i2,i3)-sy(i1-2,i2,i3))+(sy(i1+3,i2,i3)-sy(i1-3,i2,i3)))*d16(0)
       sys6(i1,i2,i3)=(45.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-9.*(sy(i1,
     & i2+2,i3)-sy(i1,i2-2,i3))+(sy(i1,i2+3,i3)-sy(i1,i2-3,i3)))*d16(
     & 1)
       syt6(i1,i2,i3)=(45.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-9.*(sy(i1,
     & i2,i3+2)-sy(i1,i2,i3-2))+(sy(i1,i2,i3+3)-sy(i1,i2,i3-3)))*d16(
     & 2)
       szr6(i1,i2,i3)=(45.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-9.*(sz(i1+2,
     & i2,i3)-sz(i1-2,i2,i3))+(sz(i1+3,i2,i3)-sz(i1-3,i2,i3)))*d16(0)
       szs6(i1,i2,i3)=(45.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-9.*(sz(i1,
     & i2+2,i3)-sz(i1,i2-2,i3))+(sz(i1,i2+3,i3)-sz(i1,i2-3,i3)))*d16(
     & 1)
       szt6(i1,i2,i3)=(45.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-9.*(sz(i1,
     & i2,i3+2)-sz(i1,i2,i3-2))+(sz(i1,i2,i3+3)-sz(i1,i2,i3-3)))*d16(
     & 2)
       txr6(i1,i2,i3)=(45.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-9.*(tx(i1+2,
     & i2,i3)-tx(i1-2,i2,i3))+(tx(i1+3,i2,i3)-tx(i1-3,i2,i3)))*d16(0)
       txs6(i1,i2,i3)=(45.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-9.*(tx(i1,
     & i2+2,i3)-tx(i1,i2-2,i3))+(tx(i1,i2+3,i3)-tx(i1,i2-3,i3)))*d16(
     & 1)
       txt6(i1,i2,i3)=(45.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-9.*(tx(i1,
     & i2,i3+2)-tx(i1,i2,i3-2))+(tx(i1,i2,i3+3)-tx(i1,i2,i3-3)))*d16(
     & 2)
       tyr6(i1,i2,i3)=(45.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-9.*(ty(i1+2,
     & i2,i3)-ty(i1-2,i2,i3))+(ty(i1+3,i2,i3)-ty(i1-3,i2,i3)))*d16(0)
       tys6(i1,i2,i3)=(45.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-9.*(ty(i1,
     & i2+2,i3)-ty(i1,i2-2,i3))+(ty(i1,i2+3,i3)-ty(i1,i2-3,i3)))*d16(
     & 1)
       tyt6(i1,i2,i3)=(45.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-9.*(ty(i1,
     & i2,i3+2)-ty(i1,i2,i3-2))+(ty(i1,i2,i3+3)-ty(i1,i2,i3-3)))*d16(
     & 2)
       tzr6(i1,i2,i3)=(45.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-9.*(tz(i1+2,
     & i2,i3)-tz(i1-2,i2,i3))+(tz(i1+3,i2,i3)-tz(i1-3,i2,i3)))*d16(0)
       tzs6(i1,i2,i3)=(45.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-9.*(tz(i1,
     & i2+2,i3)-tz(i1,i2-2,i3))+(tz(i1,i2+3,i3)-tz(i1,i2-3,i3)))*d16(
     & 1)
       tzt6(i1,i2,i3)=(45.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-9.*(tz(i1,
     & i2,i3+2)-tz(i1,i2,i3-2))+(tz(i1,i2,i3+3)-tz(i1,i2,i3-3)))*d16(
     & 2)

       ux61(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)
       uy61(i1,i2,i3,kd)=0
       uz61(i1,i2,i3,kd)=0

       ux62(i1,i2,i3,kd)= rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uy62(i1,i2,i3,kd)= ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)
       uz62(i1,i2,i3,kd)=0
       ux63(i1,i2,i3,kd)=rx(i1,i2,i3)*ur6(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tx(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uy63(i1,i2,i3,kd)=ry(i1,i2,i3)*ur6(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+ty(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uz63(i1,i2,i3,kd)=rz(i1,i2,i3)*ur6(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tz(i1,i2,i3)*ut6(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx61(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)
       rxx62(i1,i2,i3)= rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxy62(i1,i2,i3)= ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)
       rxx63(i1,i2,i3)=rx(i1,i2,i3)*rxr6(i1,i2,i3)+sx(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt6(i1,i2,i3)
       rxy63(i1,i2,i3)=ry(i1,i2,i3)*rxr6(i1,i2,i3)+sy(i1,i2,i3)*rxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt6(i1,i2,i3)
       rxz63(i1,i2,i3)=rz(i1,i2,i3)*rxr6(i1,i2,i3)+sz(i1,i2,i3)*rxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt6(i1,i2,i3)
       ryx62(i1,i2,i3)= rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryy62(i1,i2,i3)= ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)
       ryx63(i1,i2,i3)=rx(i1,i2,i3)*ryr6(i1,i2,i3)+sx(i1,i2,i3)*rys6(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt6(i1,i2,i3)
       ryy63(i1,i2,i3)=ry(i1,i2,i3)*ryr6(i1,i2,i3)+sy(i1,i2,i3)*rys6(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt6(i1,i2,i3)
       ryz63(i1,i2,i3)=rz(i1,i2,i3)*ryr6(i1,i2,i3)+sz(i1,i2,i3)*rys6(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt6(i1,i2,i3)
       rzx62(i1,i2,i3)= rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzy62(i1,i2,i3)= ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)
       rzx63(i1,i2,i3)=rx(i1,i2,i3)*rzr6(i1,i2,i3)+sx(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt6(i1,i2,i3)
       rzy63(i1,i2,i3)=ry(i1,i2,i3)*rzr6(i1,i2,i3)+sy(i1,i2,i3)*rzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt6(i1,i2,i3)
       rzz63(i1,i2,i3)=rz(i1,i2,i3)*rzr6(i1,i2,i3)+sz(i1,i2,i3)*rzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt6(i1,i2,i3)
       sxx62(i1,i2,i3)= rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxy62(i1,i2,i3)= ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)
       sxx63(i1,i2,i3)=rx(i1,i2,i3)*sxr6(i1,i2,i3)+sx(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt6(i1,i2,i3)
       sxy63(i1,i2,i3)=ry(i1,i2,i3)*sxr6(i1,i2,i3)+sy(i1,i2,i3)*sxs6(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt6(i1,i2,i3)
       sxz63(i1,i2,i3)=rz(i1,i2,i3)*sxr6(i1,i2,i3)+sz(i1,i2,i3)*sxs6(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt6(i1,i2,i3)
       syx62(i1,i2,i3)= rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syy62(i1,i2,i3)= ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)
       syx63(i1,i2,i3)=rx(i1,i2,i3)*syr6(i1,i2,i3)+sx(i1,i2,i3)*sys6(
     & i1,i2,i3)+tx(i1,i2,i3)*syt6(i1,i2,i3)
       syy63(i1,i2,i3)=ry(i1,i2,i3)*syr6(i1,i2,i3)+sy(i1,i2,i3)*sys6(
     & i1,i2,i3)+ty(i1,i2,i3)*syt6(i1,i2,i3)
       syz63(i1,i2,i3)=rz(i1,i2,i3)*syr6(i1,i2,i3)+sz(i1,i2,i3)*sys6(
     & i1,i2,i3)+tz(i1,i2,i3)*syt6(i1,i2,i3)
       szx62(i1,i2,i3)= rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szy62(i1,i2,i3)= ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)
       szx63(i1,i2,i3)=rx(i1,i2,i3)*szr6(i1,i2,i3)+sx(i1,i2,i3)*szs6(
     & i1,i2,i3)+tx(i1,i2,i3)*szt6(i1,i2,i3)
       szy63(i1,i2,i3)=ry(i1,i2,i3)*szr6(i1,i2,i3)+sy(i1,i2,i3)*szs6(
     & i1,i2,i3)+ty(i1,i2,i3)*szt6(i1,i2,i3)
       szz63(i1,i2,i3)=rz(i1,i2,i3)*szr6(i1,i2,i3)+sz(i1,i2,i3)*szs6(
     & i1,i2,i3)+tz(i1,i2,i3)*szt6(i1,i2,i3)
       txx62(i1,i2,i3)= rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txy62(i1,i2,i3)= ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)
       txx63(i1,i2,i3)=rx(i1,i2,i3)*txr6(i1,i2,i3)+sx(i1,i2,i3)*txs6(
     & i1,i2,i3)+tx(i1,i2,i3)*txt6(i1,i2,i3)
       txy63(i1,i2,i3)=ry(i1,i2,i3)*txr6(i1,i2,i3)+sy(i1,i2,i3)*txs6(
     & i1,i2,i3)+ty(i1,i2,i3)*txt6(i1,i2,i3)
       txz63(i1,i2,i3)=rz(i1,i2,i3)*txr6(i1,i2,i3)+sz(i1,i2,i3)*txs6(
     & i1,i2,i3)+tz(i1,i2,i3)*txt6(i1,i2,i3)
       tyx62(i1,i2,i3)= rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyy62(i1,i2,i3)= ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)
       tyx63(i1,i2,i3)=rx(i1,i2,i3)*tyr6(i1,i2,i3)+sx(i1,i2,i3)*tys6(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt6(i1,i2,i3)
       tyy63(i1,i2,i3)=ry(i1,i2,i3)*tyr6(i1,i2,i3)+sy(i1,i2,i3)*tys6(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt6(i1,i2,i3)
       tyz63(i1,i2,i3)=rz(i1,i2,i3)*tyr6(i1,i2,i3)+sz(i1,i2,i3)*tys6(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt6(i1,i2,i3)
       tzx62(i1,i2,i3)= rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzy62(i1,i2,i3)= ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)
       tzx63(i1,i2,i3)=rx(i1,i2,i3)*tzr6(i1,i2,i3)+sx(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt6(i1,i2,i3)
       tzy63(i1,i2,i3)=ry(i1,i2,i3)*tzr6(i1,i2,i3)+sy(i1,i2,i3)*tzs6(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt6(i1,i2,i3)
       tzz63(i1,i2,i3)=rz(i1,i2,i3)*tzr6(i1,i2,i3)+sz(i1,i2,i3)*tzs6(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt6(i1,i2,i3)

       uxx61(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(rxx62(
     & i1,i2,i3))*ur6(i1,i2,i3,kd)
       uyy61(i1,i2,i3,kd)=0
       uxy61(i1,i2,i3,kd)=0
       uxz61(i1,i2,i3,kd)=0
       uyz61(i1,i2,i3,kd)=0
       uzz61(i1,i2,i3,kd)=0
       ulaplacian61(i1,i2,i3,kd)=uxx61(i1,i2,i3,kd)
       uxx62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uyy62(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss6(i1,i2,i3,kd)+(ryy62(i1,i2,i3))*ur6(i1,i2,i3,kd)+(syy62(i1,
     & i2,i3))*us6(i1,i2,i3,kd)
       uxy62(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs6(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+rxy62(i1,
     & i2,i3)*ur6(i1,i2,i3,kd)+sxy62(i1,i2,i3)*us6(i1,i2,i3,kd)
       uxz62(i1,i2,i3,kd)=0
       uyz62(i1,i2,i3,kd)=0
       uzz62(i1,i2,i3,kd)=0
       ulaplacian62(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss6(i1,i2,i3,kd)+(rxx62(i1,i2,i3)+ryy62(i1,i2,i3))*ur6(i1,
     & i2,i3,kd)+(sxx62(i1,i2,i3)+syy62(i1,i2,i3))*us6(i1,i2,i3,kd)
       uxx63(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rxx63(i1,i2,i3)*ur6(i1,i2,i3,kd)+sxx63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+txx63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyy63(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+ryy63(i1,i2,i3)*ur6(i1,i2,i3,kd)+syy63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tyy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uzz63(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr6(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss6(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt6(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs6(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt6(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust6(
     & i1,i2,i3,kd)+rzz63(i1,i2,i3)*ur6(i1,i2,i3,kd)+szz63(i1,i2,i3)*
     & us6(i1,i2,i3,kd)+tzz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxy63(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxy63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxy63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txy63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uxz63(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs6(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust6(i1,i2,i3,kd)+rxz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+sxz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & txz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       uyz63(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr6(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss6(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt6(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs6(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt6(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust6(i1,i2,i3,kd)+ryz63(
     & i1,i2,i3)*ur6(i1,i2,i3,kd)+syz63(i1,i2,i3)*us6(i1,i2,i3,kd)+
     & tyz63(i1,i2,i3)*ut6(i1,i2,i3,kd)
       ulaplacian63(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr6(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss6(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs6(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt6(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust6(i1,i2,i3,kd)+(rxx63(i1,i2,i3)+ryy63(i1,
     & i2,i3)+rzz63(i1,i2,i3))*ur6(i1,i2,i3,kd)+(sxx63(i1,i2,i3)+
     & syy63(i1,i2,i3)+szz63(i1,i2,i3))*us6(i1,i2,i3,kd)+(txx63(i1,i2,
     & i3)+tyy63(i1,i2,i3)+tzz63(i1,i2,i3))*ut6(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h16(kd) = 1./(60.*dx(kd))
       h26(kd) = 1./(180.*dx(kd)**2)

       ux63r(i1,i2,i3,kd)=(45.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-9.*(
     & u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+(u(i1+3,i2,i3,kd)-u(i1-3,i2,
     & i3,kd)))*h16(0)
       uy63r(i1,i2,i3,kd)=(45.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-9.*(
     & u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+(u(i1,i2+3,i3,kd)-u(i1,i2-3,
     & i3,kd)))*h16(1)
       uz63r(i1,i2,i3,kd)=(45.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-9.*(
     & u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+(u(i1,i2,i3+3,kd)-u(i1,i2,
     & i3-3,kd)))*h16(2)

       uxx63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1+1,i2,i3,kd)
     & +u(i1-1,i2,i3,kd))-27.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))+2.*(
     & u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd)) )*h26(0)
       uyy63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2+1,i3,kd)
     & +u(i1,i2-1,i3,kd))-27.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))+2.*(
     & u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd)) )*h26(1)
       uzz63r(i1,i2,i3,kd)=(-490.*u(i1,i2,i3,kd)+270.*(u(i1,i2,i3+1,kd)
     & +u(i1,i2,i3-1,kd))-27.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))+2.*(
     & u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd)) )*h26(2)
       uxy63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2+1,i3,kd)-ux63r(i1,i2-1,i3,
     & kd))-9.*(ux63r(i1,i2+2,i3,kd)-ux63r(i1,i2-2,i3,kd))+(ux63r(i1,
     & i2+3,i3,kd)-ux63r(i1,i2-3,i3,kd)))*h16(1)
       uxz63r(i1,i2,i3,kd)=(45.*(ux63r(i1,i2,i3+1,kd)-ux63r(i1,i2,i3-1,
     & kd))-9.*(ux63r(i1,i2,i3+2,kd)-ux63r(i1,i2,i3-2,kd))+(ux63r(i1,
     & i2,i3+3,kd)-ux63r(i1,i2,i3-3,kd)))*h16(2)
       uyz63r(i1,i2,i3,kd)=(45.*(uy63r(i1,i2,i3+1,kd)-uy63r(i1,i2,i3-1,
     & kd))-9.*(uy63r(i1,i2,i3+2,kd)-uy63r(i1,i2,i3-2,kd))+(uy63r(i1,
     & i2,i3+3,kd)-uy63r(i1,i2,i3-3,kd)))*h16(2)

       ux61r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy61r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz61r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx61r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy61r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz61r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy61r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz61r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz61r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian61r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)
       ux62r(i1,i2,i3,kd)= ux63r(i1,i2,i3,kd)
       uy62r(i1,i2,i3,kd)= uy63r(i1,i2,i3,kd)
       uz62r(i1,i2,i3,kd)= uz63r(i1,i2,i3,kd)
       uxx62r(i1,i2,i3,kd)= uxx63r(i1,i2,i3,kd)
       uyy62r(i1,i2,i3,kd)= uyy63r(i1,i2,i3,kd)
       uzz62r(i1,i2,i3,kd)= uzz63r(i1,i2,i3,kd)
       uxy62r(i1,i2,i3,kd)= uxy63r(i1,i2,i3,kd)
       uxz62r(i1,i2,i3,kd)= uxz63r(i1,i2,i3,kd)
       uyz62r(i1,i2,i3,kd)= uyz63r(i1,i2,i3,kd)
       ulaplacian62r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)
       ulaplacian63r(i1,i2,i3,kd)=uxx63r(i1,i2,i3,kd)+uyy63r(i1,i2,i3,
     & kd)+uzz63r(i1,i2,i3,kd)
! defineDifferenceOrder8Components1(u,RX)

!        #If "RX" == "RX"
       d18(kd) = 1./(840.*dr(kd))
       d28(kd) = 1./(5040.*dr(kd)**2)

       ur8(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-168.*
     & (u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-u(i1-
     & 3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*d18(0)
       us8(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-168.*
     & (u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-u(i1,
     & i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*d18(1)
       ut8(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-168.*
     & (u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-u(i1,
     & i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*d18(2)

       urr8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*d28(0)
       uss8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*d28(1)
       utt8(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*d28(2)
       urs8(i1,i2,i3,kd)=(672.*(ur8(i1,i2+1,i3,kd)-ur8(i1,i2-1,i3,kd))-
     & 168.*(ur8(i1,i2+2,i3,kd)-ur8(i1,i2-2,i3,kd))+32.*(ur8(i1,i2+3,
     & i3,kd)-ur8(i1,i2-3,i3,kd))-3.*(ur8(i1,i2+4,i3,kd)-ur8(i1,i2-4,
     & i3,kd)))*d18(1)
       urt8(i1,i2,i3,kd)=(672.*(ur8(i1,i2,i3+1,kd)-ur8(i1,i2,i3-1,kd))-
     & 168.*(ur8(i1,i2,i3+2,kd)-ur8(i1,i2,i3-2,kd))+32.*(ur8(i1,i2,i3+
     & 3,kd)-ur8(i1,i2,i3-3,kd))-3.*(ur8(i1,i2,i3+4,kd)-ur8(i1,i2,i3-
     & 4,kd)))*d18(2)
       ust8(i1,i2,i3,kd)=(672.*(us8(i1,i2,i3+1,kd)-us8(i1,i2,i3-1,kd))-
     & 168.*(us8(i1,i2,i3+2,kd)-us8(i1,i2,i3-2,kd))+32.*(us8(i1,i2,i3+
     & 3,kd)-us8(i1,i2,i3-3,kd))-3.*(us8(i1,i2,i3+4,kd)-us8(i1,i2,i3-
     & 4,kd)))*d18(2)

!        #If "RX" == "RX"
       rxr8(i1,i2,i3)=(672.*(rx(i1+1,i2,i3)-rx(i1-1,i2,i3))-168.*(rx(
     & i1+2,i2,i3)-rx(i1-2,i2,i3))+32.*(rx(i1+3,i2,i3)-rx(i1-3,i2,i3))
     & -3.*(rx(i1+4,i2,i3)-rx(i1-4,i2,i3)))*d18(0)
       rxs8(i1,i2,i3)=(672.*(rx(i1,i2+1,i3)-rx(i1,i2-1,i3))-168.*(rx(
     & i1,i2+2,i3)-rx(i1,i2-2,i3))+32.*(rx(i1,i2+3,i3)-rx(i1,i2-3,i3))
     & -3.*(rx(i1,i2+4,i3)-rx(i1,i2-4,i3)))*d18(1)
       rxt8(i1,i2,i3)=(672.*(rx(i1,i2,i3+1)-rx(i1,i2,i3-1))-168.*(rx(
     & i1,i2,i3+2)-rx(i1,i2,i3-2))+32.*(rx(i1,i2,i3+3)-rx(i1,i2,i3-3))
     & -3.*(rx(i1,i2,i3+4)-rx(i1,i2,i3-4)))*d18(2)
       ryr8(i1,i2,i3)=(672.*(ry(i1+1,i2,i3)-ry(i1-1,i2,i3))-168.*(ry(
     & i1+2,i2,i3)-ry(i1-2,i2,i3))+32.*(ry(i1+3,i2,i3)-ry(i1-3,i2,i3))
     & -3.*(ry(i1+4,i2,i3)-ry(i1-4,i2,i3)))*d18(0)
       rys8(i1,i2,i3)=(672.*(ry(i1,i2+1,i3)-ry(i1,i2-1,i3))-168.*(ry(
     & i1,i2+2,i3)-ry(i1,i2-2,i3))+32.*(ry(i1,i2+3,i3)-ry(i1,i2-3,i3))
     & -3.*(ry(i1,i2+4,i3)-ry(i1,i2-4,i3)))*d18(1)
       ryt8(i1,i2,i3)=(672.*(ry(i1,i2,i3+1)-ry(i1,i2,i3-1))-168.*(ry(
     & i1,i2,i3+2)-ry(i1,i2,i3-2))+32.*(ry(i1,i2,i3+3)-ry(i1,i2,i3-3))
     & -3.*(ry(i1,i2,i3+4)-ry(i1,i2,i3-4)))*d18(2)
       rzr8(i1,i2,i3)=(672.*(rz(i1+1,i2,i3)-rz(i1-1,i2,i3))-168.*(rz(
     & i1+2,i2,i3)-rz(i1-2,i2,i3))+32.*(rz(i1+3,i2,i3)-rz(i1-3,i2,i3))
     & -3.*(rz(i1+4,i2,i3)-rz(i1-4,i2,i3)))*d18(0)
       rzs8(i1,i2,i3)=(672.*(rz(i1,i2+1,i3)-rz(i1,i2-1,i3))-168.*(rz(
     & i1,i2+2,i3)-rz(i1,i2-2,i3))+32.*(rz(i1,i2+3,i3)-rz(i1,i2-3,i3))
     & -3.*(rz(i1,i2+4,i3)-rz(i1,i2-4,i3)))*d18(1)
       rzt8(i1,i2,i3)=(672.*(rz(i1,i2,i3+1)-rz(i1,i2,i3-1))-168.*(rz(
     & i1,i2,i3+2)-rz(i1,i2,i3-2))+32.*(rz(i1,i2,i3+3)-rz(i1,i2,i3-3))
     & -3.*(rz(i1,i2,i3+4)-rz(i1,i2,i3-4)))*d18(2)
       sxr8(i1,i2,i3)=(672.*(sx(i1+1,i2,i3)-sx(i1-1,i2,i3))-168.*(sx(
     & i1+2,i2,i3)-sx(i1-2,i2,i3))+32.*(sx(i1+3,i2,i3)-sx(i1-3,i2,i3))
     & -3.*(sx(i1+4,i2,i3)-sx(i1-4,i2,i3)))*d18(0)
       sxs8(i1,i2,i3)=(672.*(sx(i1,i2+1,i3)-sx(i1,i2-1,i3))-168.*(sx(
     & i1,i2+2,i3)-sx(i1,i2-2,i3))+32.*(sx(i1,i2+3,i3)-sx(i1,i2-3,i3))
     & -3.*(sx(i1,i2+4,i3)-sx(i1,i2-4,i3)))*d18(1)
       sxt8(i1,i2,i3)=(672.*(sx(i1,i2,i3+1)-sx(i1,i2,i3-1))-168.*(sx(
     & i1,i2,i3+2)-sx(i1,i2,i3-2))+32.*(sx(i1,i2,i3+3)-sx(i1,i2,i3-3))
     & -3.*(sx(i1,i2,i3+4)-sx(i1,i2,i3-4)))*d18(2)
       syr8(i1,i2,i3)=(672.*(sy(i1+1,i2,i3)-sy(i1-1,i2,i3))-168.*(sy(
     & i1+2,i2,i3)-sy(i1-2,i2,i3))+32.*(sy(i1+3,i2,i3)-sy(i1-3,i2,i3))
     & -3.*(sy(i1+4,i2,i3)-sy(i1-4,i2,i3)))*d18(0)
       sys8(i1,i2,i3)=(672.*(sy(i1,i2+1,i3)-sy(i1,i2-1,i3))-168.*(sy(
     & i1,i2+2,i3)-sy(i1,i2-2,i3))+32.*(sy(i1,i2+3,i3)-sy(i1,i2-3,i3))
     & -3.*(sy(i1,i2+4,i3)-sy(i1,i2-4,i3)))*d18(1)
       syt8(i1,i2,i3)=(672.*(sy(i1,i2,i3+1)-sy(i1,i2,i3-1))-168.*(sy(
     & i1,i2,i3+2)-sy(i1,i2,i3-2))+32.*(sy(i1,i2,i3+3)-sy(i1,i2,i3-3))
     & -3.*(sy(i1,i2,i3+4)-sy(i1,i2,i3-4)))*d18(2)
       szr8(i1,i2,i3)=(672.*(sz(i1+1,i2,i3)-sz(i1-1,i2,i3))-168.*(sz(
     & i1+2,i2,i3)-sz(i1-2,i2,i3))+32.*(sz(i1+3,i2,i3)-sz(i1-3,i2,i3))
     & -3.*(sz(i1+4,i2,i3)-sz(i1-4,i2,i3)))*d18(0)
       szs8(i1,i2,i3)=(672.*(sz(i1,i2+1,i3)-sz(i1,i2-1,i3))-168.*(sz(
     & i1,i2+2,i3)-sz(i1,i2-2,i3))+32.*(sz(i1,i2+3,i3)-sz(i1,i2-3,i3))
     & -3.*(sz(i1,i2+4,i3)-sz(i1,i2-4,i3)))*d18(1)
       szt8(i1,i2,i3)=(672.*(sz(i1,i2,i3+1)-sz(i1,i2,i3-1))-168.*(sz(
     & i1,i2,i3+2)-sz(i1,i2,i3-2))+32.*(sz(i1,i2,i3+3)-sz(i1,i2,i3-3))
     & -3.*(sz(i1,i2,i3+4)-sz(i1,i2,i3-4)))*d18(2)
       txr8(i1,i2,i3)=(672.*(tx(i1+1,i2,i3)-tx(i1-1,i2,i3))-168.*(tx(
     & i1+2,i2,i3)-tx(i1-2,i2,i3))+32.*(tx(i1+3,i2,i3)-tx(i1-3,i2,i3))
     & -3.*(tx(i1+4,i2,i3)-tx(i1-4,i2,i3)))*d18(0)
       txs8(i1,i2,i3)=(672.*(tx(i1,i2+1,i3)-tx(i1,i2-1,i3))-168.*(tx(
     & i1,i2+2,i3)-tx(i1,i2-2,i3))+32.*(tx(i1,i2+3,i3)-tx(i1,i2-3,i3))
     & -3.*(tx(i1,i2+4,i3)-tx(i1,i2-4,i3)))*d18(1)
       txt8(i1,i2,i3)=(672.*(tx(i1,i2,i3+1)-tx(i1,i2,i3-1))-168.*(tx(
     & i1,i2,i3+2)-tx(i1,i2,i3-2))+32.*(tx(i1,i2,i3+3)-tx(i1,i2,i3-3))
     & -3.*(tx(i1,i2,i3+4)-tx(i1,i2,i3-4)))*d18(2)
       tyr8(i1,i2,i3)=(672.*(ty(i1+1,i2,i3)-ty(i1-1,i2,i3))-168.*(ty(
     & i1+2,i2,i3)-ty(i1-2,i2,i3))+32.*(ty(i1+3,i2,i3)-ty(i1-3,i2,i3))
     & -3.*(ty(i1+4,i2,i3)-ty(i1-4,i2,i3)))*d18(0)
       tys8(i1,i2,i3)=(672.*(ty(i1,i2+1,i3)-ty(i1,i2-1,i3))-168.*(ty(
     & i1,i2+2,i3)-ty(i1,i2-2,i3))+32.*(ty(i1,i2+3,i3)-ty(i1,i2-3,i3))
     & -3.*(ty(i1,i2+4,i3)-ty(i1,i2-4,i3)))*d18(1)
       tyt8(i1,i2,i3)=(672.*(ty(i1,i2,i3+1)-ty(i1,i2,i3-1))-168.*(ty(
     & i1,i2,i3+2)-ty(i1,i2,i3-2))+32.*(ty(i1,i2,i3+3)-ty(i1,i2,i3-3))
     & -3.*(ty(i1,i2,i3+4)-ty(i1,i2,i3-4)))*d18(2)
       tzr8(i1,i2,i3)=(672.*(tz(i1+1,i2,i3)-tz(i1-1,i2,i3))-168.*(tz(
     & i1+2,i2,i3)-tz(i1-2,i2,i3))+32.*(tz(i1+3,i2,i3)-tz(i1-3,i2,i3))
     & -3.*(tz(i1+4,i2,i3)-tz(i1-4,i2,i3)))*d18(0)
       tzs8(i1,i2,i3)=(672.*(tz(i1,i2+1,i3)-tz(i1,i2-1,i3))-168.*(tz(
     & i1,i2+2,i3)-tz(i1,i2-2,i3))+32.*(tz(i1,i2+3,i3)-tz(i1,i2-3,i3))
     & -3.*(tz(i1,i2+4,i3)-tz(i1,i2-4,i3)))*d18(1)
       tzt8(i1,i2,i3)=(672.*(tz(i1,i2,i3+1)-tz(i1,i2,i3-1))-168.*(tz(
     & i1,i2,i3+2)-tz(i1,i2,i3-2))+32.*(tz(i1,i2,i3+3)-tz(i1,i2,i3-3))
     & -3.*(tz(i1,i2,i3+4)-tz(i1,i2,i3-4)))*d18(2)

       ux81(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)
       uy81(i1,i2,i3,kd)=0
       uz81(i1,i2,i3,kd)=0

       ux82(i1,i2,i3,kd)= rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uy82(i1,i2,i3,kd)= ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)
       uz82(i1,i2,i3,kd)=0
       ux83(i1,i2,i3,kd)=rx(i1,i2,i3)*ur8(i1,i2,i3,kd)+sx(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tx(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uy83(i1,i2,i3,kd)=ry(i1,i2,i3)*ur8(i1,i2,i3,kd)+sy(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+ty(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uz83(i1,i2,i3,kd)=rz(i1,i2,i3)*ur8(i1,i2,i3,kd)+sz(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tz(i1,i2,i3)*ut8(i1,i2,i3,kd)

!        #If "RX" == "RX"
       rxx81(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)
       rxx82(i1,i2,i3)= rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxy82(i1,i2,i3)= ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)
       rxx83(i1,i2,i3)=rx(i1,i2,i3)*rxr8(i1,i2,i3)+sx(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rxt8(i1,i2,i3)
       rxy83(i1,i2,i3)=ry(i1,i2,i3)*rxr8(i1,i2,i3)+sy(i1,i2,i3)*rxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rxt8(i1,i2,i3)
       rxz83(i1,i2,i3)=rz(i1,i2,i3)*rxr8(i1,i2,i3)+sz(i1,i2,i3)*rxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rxt8(i1,i2,i3)
       ryx82(i1,i2,i3)= rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryy82(i1,i2,i3)= ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)
       ryx83(i1,i2,i3)=rx(i1,i2,i3)*ryr8(i1,i2,i3)+sx(i1,i2,i3)*rys8(
     & i1,i2,i3)+tx(i1,i2,i3)*ryt8(i1,i2,i3)
       ryy83(i1,i2,i3)=ry(i1,i2,i3)*ryr8(i1,i2,i3)+sy(i1,i2,i3)*rys8(
     & i1,i2,i3)+ty(i1,i2,i3)*ryt8(i1,i2,i3)
       ryz83(i1,i2,i3)=rz(i1,i2,i3)*ryr8(i1,i2,i3)+sz(i1,i2,i3)*rys8(
     & i1,i2,i3)+tz(i1,i2,i3)*ryt8(i1,i2,i3)
       rzx82(i1,i2,i3)= rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzy82(i1,i2,i3)= ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)
       rzx83(i1,i2,i3)=rx(i1,i2,i3)*rzr8(i1,i2,i3)+sx(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*rzt8(i1,i2,i3)
       rzy83(i1,i2,i3)=ry(i1,i2,i3)*rzr8(i1,i2,i3)+sy(i1,i2,i3)*rzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*rzt8(i1,i2,i3)
       rzz83(i1,i2,i3)=rz(i1,i2,i3)*rzr8(i1,i2,i3)+sz(i1,i2,i3)*rzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*rzt8(i1,i2,i3)
       sxx82(i1,i2,i3)= rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxy82(i1,i2,i3)= ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)
       sxx83(i1,i2,i3)=rx(i1,i2,i3)*sxr8(i1,i2,i3)+sx(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tx(i1,i2,i3)*sxt8(i1,i2,i3)
       sxy83(i1,i2,i3)=ry(i1,i2,i3)*sxr8(i1,i2,i3)+sy(i1,i2,i3)*sxs8(
     & i1,i2,i3)+ty(i1,i2,i3)*sxt8(i1,i2,i3)
       sxz83(i1,i2,i3)=rz(i1,i2,i3)*sxr8(i1,i2,i3)+sz(i1,i2,i3)*sxs8(
     & i1,i2,i3)+tz(i1,i2,i3)*sxt8(i1,i2,i3)
       syx82(i1,i2,i3)= rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syy82(i1,i2,i3)= ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)
       syx83(i1,i2,i3)=rx(i1,i2,i3)*syr8(i1,i2,i3)+sx(i1,i2,i3)*sys8(
     & i1,i2,i3)+tx(i1,i2,i3)*syt8(i1,i2,i3)
       syy83(i1,i2,i3)=ry(i1,i2,i3)*syr8(i1,i2,i3)+sy(i1,i2,i3)*sys8(
     & i1,i2,i3)+ty(i1,i2,i3)*syt8(i1,i2,i3)
       syz83(i1,i2,i3)=rz(i1,i2,i3)*syr8(i1,i2,i3)+sz(i1,i2,i3)*sys8(
     & i1,i2,i3)+tz(i1,i2,i3)*syt8(i1,i2,i3)
       szx82(i1,i2,i3)= rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szy82(i1,i2,i3)= ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)
       szx83(i1,i2,i3)=rx(i1,i2,i3)*szr8(i1,i2,i3)+sx(i1,i2,i3)*szs8(
     & i1,i2,i3)+tx(i1,i2,i3)*szt8(i1,i2,i3)
       szy83(i1,i2,i3)=ry(i1,i2,i3)*szr8(i1,i2,i3)+sy(i1,i2,i3)*szs8(
     & i1,i2,i3)+ty(i1,i2,i3)*szt8(i1,i2,i3)
       szz83(i1,i2,i3)=rz(i1,i2,i3)*szr8(i1,i2,i3)+sz(i1,i2,i3)*szs8(
     & i1,i2,i3)+tz(i1,i2,i3)*szt8(i1,i2,i3)
       txx82(i1,i2,i3)= rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txy82(i1,i2,i3)= ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)
       txx83(i1,i2,i3)=rx(i1,i2,i3)*txr8(i1,i2,i3)+sx(i1,i2,i3)*txs8(
     & i1,i2,i3)+tx(i1,i2,i3)*txt8(i1,i2,i3)
       txy83(i1,i2,i3)=ry(i1,i2,i3)*txr8(i1,i2,i3)+sy(i1,i2,i3)*txs8(
     & i1,i2,i3)+ty(i1,i2,i3)*txt8(i1,i2,i3)
       txz83(i1,i2,i3)=rz(i1,i2,i3)*txr8(i1,i2,i3)+sz(i1,i2,i3)*txs8(
     & i1,i2,i3)+tz(i1,i2,i3)*txt8(i1,i2,i3)
       tyx82(i1,i2,i3)= rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyy82(i1,i2,i3)= ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)
       tyx83(i1,i2,i3)=rx(i1,i2,i3)*tyr8(i1,i2,i3)+sx(i1,i2,i3)*tys8(
     & i1,i2,i3)+tx(i1,i2,i3)*tyt8(i1,i2,i3)
       tyy83(i1,i2,i3)=ry(i1,i2,i3)*tyr8(i1,i2,i3)+sy(i1,i2,i3)*tys8(
     & i1,i2,i3)+ty(i1,i2,i3)*tyt8(i1,i2,i3)
       tyz83(i1,i2,i3)=rz(i1,i2,i3)*tyr8(i1,i2,i3)+sz(i1,i2,i3)*tys8(
     & i1,i2,i3)+tz(i1,i2,i3)*tyt8(i1,i2,i3)
       tzx82(i1,i2,i3)= rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzy82(i1,i2,i3)= ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)
       tzx83(i1,i2,i3)=rx(i1,i2,i3)*tzr8(i1,i2,i3)+sx(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tx(i1,i2,i3)*tzt8(i1,i2,i3)
       tzy83(i1,i2,i3)=ry(i1,i2,i3)*tzr8(i1,i2,i3)+sy(i1,i2,i3)*tzs8(
     & i1,i2,i3)+ty(i1,i2,i3)*tzt8(i1,i2,i3)
       tzz83(i1,i2,i3)=rz(i1,i2,i3)*tzr8(i1,i2,i3)+sz(i1,i2,i3)*tzs8(
     & i1,i2,i3)+tz(i1,i2,i3)*tzt8(i1,i2,i3)

       uxx81(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(rxx82(
     & i1,i2,i3))*ur8(i1,i2,i3,kd)
       uyy81(i1,i2,i3,kd)=0
       uxy81(i1,i2,i3,kd)=0
       uxz81(i1,i2,i3,kd)=0
       uyz81(i1,i2,i3,kd)=0
       uzz81(i1,i2,i3,kd)=0
       ulaplacian81(i1,i2,i3,kd)=uxx81(i1,i2,i3,kd)
       uxx82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(rx(
     & i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uyy82(i1,i2,i3,kd)=(ry(i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+2.*(ry(
     & i1,i2,i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sy(i1,i2,i3)**2)*
     & uss8(i1,i2,i3,kd)+(ryy82(i1,i2,i3))*ur8(i1,i2,i3,kd)+(syy82(i1,
     & i2,i3))*us8(i1,i2,i3,kd)
       uxy82(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+(
     & rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,i3)*sx(i1,i2,i3))*urs8(i1,
     & i2,i3,kd)+sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+rxy82(i1,
     & i2,i3)*ur8(i1,i2,i3,kd)+sxy82(i1,i2,i3)*us8(i1,i2,i3,kd)
       uxz82(i1,i2,i3,kd)=0
       uyz82(i1,i2,i3,kd)=0
       uzz82(i1,i2,i3,kd)=0
       ulaplacian82(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2)*
     & urr8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(i1,i2,i3)+ ry(i1,i2,i3)*
     & sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2)*uss8(i1,i2,i3,kd)+(rxx82(i1,i2,i3)+ryy82(i1,i2,i3))*ur8(i1,
     & i2,i3,kd)+(sxx82(i1,i2,i3)+syy82(i1,i2,i3))*us8(i1,i2,i3,kd)
       uxx83(i1,i2,i3,kd)=rx(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sx(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rx(i1,i2,i3)*sx(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rx(i1,i2,i3)*tx(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sx(i1,i2,i3)*tx(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rxx83(i1,i2,i3)*ur8(i1,i2,i3,kd)+sxx83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+txx83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyy83(i1,i2,i3,kd)=ry(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sy(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & ry(i1,i2,i3)*sy(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*ry(i1,i2,i3)*ty(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sy(i1,i2,i3)*ty(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+ryy83(i1,i2,i3)*ur8(i1,i2,i3,kd)+syy83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tyy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uzz83(i1,i2,i3,kd)=rz(i1,i2,i3)**2*urr8(i1,i2,i3,kd)+sz(i1,i2,
     & i3)**2*uss8(i1,i2,i3,kd)+tz(i1,i2,i3)**2*utt8(i1,i2,i3,kd)+2.*
     & rz(i1,i2,i3)*sz(i1,i2,i3)*urs8(i1,i2,i3,kd)+2.*rz(i1,i2,i3)*tz(
     & i1,i2,i3)*urt8(i1,i2,i3,kd)+2.*sz(i1,i2,i3)*tz(i1,i2,i3)*ust8(
     & i1,i2,i3,kd)+rzz83(i1,i2,i3)*ur8(i1,i2,i3,kd)+szz83(i1,i2,i3)*
     & us8(i1,i2,i3,kd)+tzz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxy83(i1,i2,i3,kd)=rx(i1,i2,i3)*ry(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sy(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*ty(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sy(i1,i2,i3)+ry(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*ty(i1,i2,i3)+
     & ry(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*ty(
     & i1,i2,i3)+sy(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxy83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxy83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txy83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uxz83(i1,i2,i3,kd)=rx(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sx(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+tx(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(rx(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sx(i1,i2,i3))*urs8(i1,i2,i3,kd)+(rx(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*tx(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sx(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*tx(i1,i2,i3))*ust8(i1,i2,i3,kd)+rxz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+sxz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & txz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       uyz83(i1,i2,i3,kd)=ry(i1,i2,i3)*rz(i1,i2,i3)*urr8(i1,i2,i3,kd)+
     & sy(i1,i2,i3)*sz(i1,i2,i3)*uss8(i1,i2,i3,kd)+ty(i1,i2,i3)*tz(i1,
     & i2,i3)*utt8(i1,i2,i3,kd)+(ry(i1,i2,i3)*sz(i1,i2,i3)+rz(i1,i2,
     & i3)*sy(i1,i2,i3))*urs8(i1,i2,i3,kd)+(ry(i1,i2,i3)*tz(i1,i2,i3)+
     & rz(i1,i2,i3)*ty(i1,i2,i3))*urt8(i1,i2,i3,kd)+(sy(i1,i2,i3)*tz(
     & i1,i2,i3)+sz(i1,i2,i3)*ty(i1,i2,i3))*ust8(i1,i2,i3,kd)+ryz83(
     & i1,i2,i3)*ur8(i1,i2,i3,kd)+syz83(i1,i2,i3)*us8(i1,i2,i3,kd)+
     & tyz83(i1,i2,i3)*ut8(i1,i2,i3,kd)
       ulaplacian83(i1,i2,i3,kd)=(rx(i1,i2,i3)**2+ry(i1,i2,i3)**2+rz(
     & i1,i2,i3)**2)*urr8(i1,i2,i3,kd)+(sx(i1,i2,i3)**2+sy(i1,i2,i3)**
     & 2+sz(i1,i2,i3)**2)*uss8(i1,i2,i3,kd)+(tx(i1,i2,i3)**2+ty(i1,i2,
     & i3)**2+tz(i1,i2,i3)**2)*utt8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*sx(
     & i1,i2,i3)+ ry(i1,i2,i3)*sy(i1,i2,i3)+rz(i1,i2,i3)*sz(i1,i2,i3))
     & *urs8(i1,i2,i3,kd)+2.*(rx(i1,i2,i3)*tx(i1,i2,i3)+ ry(i1,i2,i3)*
     & ty(i1,i2,i3)+rz(i1,i2,i3)*tz(i1,i2,i3))*urt8(i1,i2,i3,kd)+2.*(
     & sx(i1,i2,i3)*tx(i1,i2,i3)+ sy(i1,i2,i3)*ty(i1,i2,i3)+sz(i1,i2,
     & i3)*tz(i1,i2,i3))*ust8(i1,i2,i3,kd)+(rxx83(i1,i2,i3)+ryy83(i1,
     & i2,i3)+rzz83(i1,i2,i3))*ur8(i1,i2,i3,kd)+(sxx83(i1,i2,i3)+
     & syy83(i1,i2,i3)+szz83(i1,i2,i3))*us8(i1,i2,i3,kd)+(txx83(i1,i2,
     & i3)+tyy83(i1,i2,i3)+tzz83(i1,i2,i3))*ut8(i1,i2,i3,kd)
c============================================================================================
c Define derivatives for a rectangular grid
c
c============================================================================================
!        #If "RX" == "RX"
       h18(kd) = 1./(840.*dx(kd))
       h28(kd) = 1./(5040.*dx(kd)**2)

       ux83r(i1,i2,i3,kd)=(672.*(u(i1+1,i2,i3,kd)-u(i1-1,i2,i3,kd))-
     & 168.*(u(i1+2,i2,i3,kd)-u(i1-2,i2,i3,kd))+32.*(u(i1+3,i2,i3,kd)-
     & u(i1-3,i2,i3,kd))-3.*(u(i1+4,i2,i3,kd)-u(i1-4,i2,i3,kd)))*h18(
     & 0)
       uy83r(i1,i2,i3,kd)=(672.*(u(i1,i2+1,i3,kd)-u(i1,i2-1,i3,kd))-
     & 168.*(u(i1,i2+2,i3,kd)-u(i1,i2-2,i3,kd))+32.*(u(i1,i2+3,i3,kd)-
     & u(i1,i2-3,i3,kd))-3.*(u(i1,i2+4,i3,kd)-u(i1,i2-4,i3,kd)))*h18(
     & 1)
       uz83r(i1,i2,i3,kd)=(672.*(u(i1,i2,i3+1,kd)-u(i1,i2,i3-1,kd))-
     & 168.*(u(i1,i2,i3+2,kd)-u(i1,i2,i3-2,kd))+32.*(u(i1,i2,i3+3,kd)-
     & u(i1,i2,i3-3,kd))-3.*(u(i1,i2,i3+4,kd)-u(i1,i2,i3-4,kd)))*h18(
     & 2)

       uxx83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1+1,i2,i3,
     & kd)+u(i1-1,i2,i3,kd))-1008.*(u(i1+2,i2,i3,kd)+u(i1-2,i2,i3,kd))
     & +128.*(u(i1+3,i2,i3,kd)+u(i1-3,i2,i3,kd))-9.*(u(i1+4,i2,i3,kd)+
     & u(i1-4,i2,i3,kd)) )*h28(0)
       uyy83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2+1,i3,
     & kd)+u(i1,i2-1,i3,kd))-1008.*(u(i1,i2+2,i3,kd)+u(i1,i2-2,i3,kd))
     & +128.*(u(i1,i2+3,i3,kd)+u(i1,i2-3,i3,kd))-9.*(u(i1,i2+4,i3,kd)+
     & u(i1,i2-4,i3,kd)) )*h28(1)
       uzz83r(i1,i2,i3,kd)=(-14350.*u(i1,i2,i3,kd)+8064.*(u(i1,i2,i3+1,
     & kd)+u(i1,i2,i3-1,kd))-1008.*(u(i1,i2,i3+2,kd)+u(i1,i2,i3-2,kd))
     & +128.*(u(i1,i2,i3+3,kd)+u(i1,i2,i3-3,kd))-9.*(u(i1,i2,i3+4,kd)+
     & u(i1,i2,i3-4,kd)) )*h28(2)
       uxy83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2+1,i3,kd)-ux83r(i1,i2-1,
     & i3,kd))-168.*(ux83r(i1,i2+2,i3,kd)-ux83r(i1,i2-2,i3,kd))+32.*(
     & ux83r(i1,i2+3,i3,kd)-ux83r(i1,i2-3,i3,kd))-3.*(ux83r(i1,i2+4,
     & i3,kd)-ux83r(i1,i2-4,i3,kd)))*h18(1)
       uxz83r(i1,i2,i3,kd)=(672.*(ux83r(i1,i2,i3+1,kd)-ux83r(i1,i2,i3-
     & 1,kd))-168.*(ux83r(i1,i2,i3+2,kd)-ux83r(i1,i2,i3-2,kd))+32.*(
     & ux83r(i1,i2,i3+3,kd)-ux83r(i1,i2,i3-3,kd))-3.*(ux83r(i1,i2,i3+
     & 4,kd)-ux83r(i1,i2,i3-4,kd)))*h18(2)
       uyz83r(i1,i2,i3,kd)=(672.*(uy83r(i1,i2,i3+1,kd)-uy83r(i1,i2,i3-
     & 1,kd))-168.*(uy83r(i1,i2,i3+2,kd)-uy83r(i1,i2,i3-2,kd))+32.*(
     & uy83r(i1,i2,i3+3,kd)-uy83r(i1,i2,i3-3,kd))-3.*(uy83r(i1,i2,i3+
     & 4,kd)-uy83r(i1,i2,i3-4,kd)))*h18(2)

       ux81r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy81r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz81r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx81r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy81r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz81r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy81r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz81r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz81r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian81r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)
       ux82r(i1,i2,i3,kd)= ux83r(i1,i2,i3,kd)
       uy82r(i1,i2,i3,kd)= uy83r(i1,i2,i3,kd)
       uz82r(i1,i2,i3,kd)= uz83r(i1,i2,i3,kd)
       uxx82r(i1,i2,i3,kd)= uxx83r(i1,i2,i3,kd)
       uyy82r(i1,i2,i3,kd)= uyy83r(i1,i2,i3,kd)
       uzz82r(i1,i2,i3,kd)= uzz83r(i1,i2,i3,kd)
       uxy82r(i1,i2,i3,kd)= uxy83r(i1,i2,i3,kd)
       uxz82r(i1,i2,i3,kd)= uxz83r(i1,i2,i3,kd)
       uyz82r(i1,i2,i3,kd)= uyz83r(i1,i2,i3,kd)
       ulaplacian82r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)
       ulaplacian83r(i1,i2,i3,kd)=uxx83r(i1,i2,i3,kd)+uyy83r(i1,i2,i3,
     & kd)+uzz83r(i1,i2,i3,kd)

       n1a     =ipar(0)
       n1b     =ipar(1)
       n2a     =ipar(2)
       n2b     =ipar(3)
       n3a     =ipar(4)
       n3b     =ipar(5)
       ca      =ipar(6)
       cb      =ipar(7)
       gridType=ipar(8)
       order   =ipar(9)

       dr(0)=rpar(0)
       dr(1)=rpar(1)
       dr(2)=rpar(2)
       dx(0)=rpar(3)
       dx(1)=rpar(4)
       dx(2)=rpar(5)

       ndc=ndu4b-ndu4a+1 ! number of components

!       #If "vorticity" == "grad"
!       #Elif "vorticity" == div
!       #Elif "vorticity" == vorticity
c  --- vorticity ---
        if( order.eq.2 )then
! vorticityLoop(2)
c if( ca.ne.0 .or. cb.ne.0 )then
c   write(*,*) 'deriv of vorticity:ERROR ca,cb!=0'
c   stop 1
c end if
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux22r(i1,i2,i3,1)-uy22r(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux22r(i1,i2,i3,1)-uy22r(i1,i2,i3,
     & 0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy23r(i1,i2,i3,2)-uz23r(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz23r(i1,i2,i3,0)-ux23r(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux23r(i1,i2,i3,1)-uy23r(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy23r(i1,i2,i3,2)-uz23r(i1,i2,i3,
     & 1)
                   deriv(i1,i2,i3,1)=uz23r(i1,i2,i3,0)-ux23r(i1,i2,i3,
     & 2)
                   deriv(i1,i2,i3,2)=ux23r(i1,i2,i3,1)-uy23r(i1,i2,i3,
     & 0)
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux22(i1,i2,i3,1)-uy22(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux22(i1,i2,i3,1)-uy22(i1,i2,i3,0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy23(i1,i2,i3,2)-uz23(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz23(i1,i2,i3,0)-ux23(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux23(i1,i2,i3,1)-uy23(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy23(i1,i2,i3,2)-uz23(i1,i2,i3,1)
                   deriv(i1,i2,i3,1)=uz23(i1,i2,i3,0)-ux23(i1,i2,i3,2)
                   deriv(i1,i2,i3,2)=ux23(i1,i2,i3,1)-uy23(i1,i2,i3,0)
                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.4 )then
! vorticityLoop(4)
c if( ca.ne.0 .or. cb.ne.0 )then
c   write(*,*) 'deriv of vorticity:ERROR ca,cb!=0'
c   stop 1
c end if
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux42r(i1,i2,i3,1)-uy42r(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux42r(i1,i2,i3,1)-uy42r(i1,i2,i3,
     & 0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy43r(i1,i2,i3,2)-uz43r(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz43r(i1,i2,i3,0)-ux43r(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux43r(i1,i2,i3,1)-uy43r(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy43r(i1,i2,i3,2)-uz43r(i1,i2,i3,
     & 1)
                   deriv(i1,i2,i3,1)=uz43r(i1,i2,i3,0)-ux43r(i1,i2,i3,
     & 2)
                   deriv(i1,i2,i3,2)=ux43r(i1,i2,i3,1)-uy43r(i1,i2,i3,
     & 0)
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux42(i1,i2,i3,1)-uy42(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux42(i1,i2,i3,1)-uy42(i1,i2,i3,0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy43(i1,i2,i3,2)-uz43(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz43(i1,i2,i3,0)-ux43(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux43(i1,i2,i3,1)-uy43(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy43(i1,i2,i3,2)-uz43(i1,i2,i3,1)
                   deriv(i1,i2,i3,1)=uz43(i1,i2,i3,0)-ux43(i1,i2,i3,2)
                   deriv(i1,i2,i3,2)=ux43(i1,i2,i3,1)-uy43(i1,i2,i3,0)
                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.6 )then
! vorticityLoop(6)
c if( ca.ne.0 .or. cb.ne.0 )then
c   write(*,*) 'deriv of vorticity:ERROR ca,cb!=0'
c   stop 1
c end if
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux62r(i1,i2,i3,1)-uy62r(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux62r(i1,i2,i3,1)-uy62r(i1,i2,i3,
     & 0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy63r(i1,i2,i3,2)-uz63r(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz63r(i1,i2,i3,0)-ux63r(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux63r(i1,i2,i3,1)-uy63r(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy63r(i1,i2,i3,2)-uz63r(i1,i2,i3,
     & 1)
                   deriv(i1,i2,i3,1)=uz63r(i1,i2,i3,0)-ux63r(i1,i2,i3,
     & 2)
                   deriv(i1,i2,i3,2)=ux63r(i1,i2,i3,1)-uy63r(i1,i2,i3,
     & 0)
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux62(i1,i2,i3,1)-uy62(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux62(i1,i2,i3,1)-uy62(i1,i2,i3,0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy63(i1,i2,i3,2)-uz63(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz63(i1,i2,i3,0)-ux63(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux63(i1,i2,i3,1)-uy63(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy63(i1,i2,i3,2)-uz63(i1,i2,i3,1)
                   deriv(i1,i2,i3,1)=uz63(i1,i2,i3,0)-ux63(i1,i2,i3,2)
                   deriv(i1,i2,i3,2)=ux63(i1,i2,i3,1)-uy63(i1,i2,i3,0)
                 end do
                 end do
                 end do
             end if
           endif
        else if( order.eq.8 )then
! vorticityLoop(8)
c if( ca.ne.0 .or. cb.ne.0 )then
c   write(*,*) 'deriv of vorticity:ERROR ca,cb!=0'
c   stop 1
c end if
           if( gridType .eq. rectangular )then
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux82r(i1,i2,i3,1)-uy82r(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux82r(i1,i2,i3,1)-uy82r(i1,i2,i3,
     & 0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy83r(i1,i2,i3,2)-uz83r(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz83r(i1,i2,i3,0)-ux83r(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux83r(i1,i2,i3,1)-uy83r(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy83r(i1,i2,i3,2)-uz83r(i1,i2,i3,
     & 1)
                   deriv(i1,i2,i3,1)=uz83r(i1,i2,i3,0)-ux83r(i1,i2,i3,
     & 2)
                   deriv(i1,i2,i3,2)=ux83r(i1,i2,i3,1)-uy83r(i1,i2,i3,
     & 0)
                 end do
                 end do
                 end do
             end if
           else
             if( nd.eq.2 )then
! loops3nc(deriv(i1,i2,i3,0)=ux82(i1,i2,i3,1)-uy82(i1,i2,i3,0),,)
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=ux82(i1,i2,i3,1)-uy82(i1,i2,i3,0)


                 end do
                 end do
                 end do
             else if( nd.eq.3 )then
! loops3nc(deriv(i1,i2,i3,0)=uy83(i1,i2,i3,2)-uz83(i1,i2,i3,1),deriv(i1,i2,i3,1)=uz83(i1,i2,i3,0)-ux83(i1,i2,i3,2),deriv(i1,i2,i3,2)=ux83(i1,i2,i3,1)-uy83(i1,i2,i3,0))
                 do i3=n3a,n3b
                 do i2=n2a,n2b
                 do i1=n1a,n1b
                   deriv(i1,i2,i3,0)=uy83(i1,i2,i3,2)-uz83(i1,i2,i3,1)
                   deriv(i1,i2,i3,1)=uz83(i1,i2,i3,0)-ux83(i1,i2,i3,2)
                   deriv(i1,i2,i3,2)=ux83(i1,i2,i3,1)-uy83(i1,i2,i3,0)
                 end do
                 end do
                 end do
             end if
           endif
        end if



c if( nd .eq. 2 )then
cc       ******* 2D *************      
c   if( gridType .eq. rectangular )then
cc         rectangular
c     loops(deriv(i1,i2,i3,c)=uvorticityORDER2r(i1,i2,i3,c))
c   else
cc         ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uvorticityORDER2(i1,i2,i3,c))
c   endif 
c elseif( nd.eq.3 )then
cc  ******* 3D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uvorticityORDER3r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uvorticityORDER3(i1,i2,i3,c))
c   endif 
c 
c elseif( nd.eq.1 )then
cc  ******* 1D *************      
c   if( gridType .eq. rectangular )then
cc    rectangular
c     loops(deriv(i1,i2,i3,c)=uvorticityORDER1r(i1,i2,i3,c))
c   else
cc    ***** not rectangular *****
c     loops(deriv(i1,i2,i3,c)=uvorticityORDER1(i1,i2,i3,c))
c   endif 
c 
c else if( nd.eq.0 )then
cc  *** add these lines to avoid warnings about unused statement functions
cc  include "cgux2afNoWarnings.h" 
cc  include "cgux4afNoWarnings.h" 
c end if

       return
       end

c
c      finiteDifferenceDerivative(laplacian)
c      finiteDifferenceDerivative(laplacian,4)
c      finiteDifferenceDerivative(x,8)
c      finiteDifferenceDerivative(y,8)
c      finiteDifferenceDerivative(z,8)
c      finiteDifferenceDerivative(xx,8)
c      finiteDifferenceDerivative(xy,8)
c      finiteDifferenceDerivative(xz,8)
c      finiteDifferenceDerivative(yy,8)
c      finiteDifferenceDerivative(yz,8)
c      finiteDifferenceDerivative(zz,8)
c      finiteDifferenceDerivative(laplacian,8)


